"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lang = require("../lang");

var generateProjectId = (config = {}) => {
  if (config.test) {
    (0, _lang.invariant)(config.test.runId, 'config.test.runId must be defined');

    if (config.test.integration) {
      (0, _lang.invariant)(config.firebase.projectId, 'config.firebase.projectId must be defined when config.test.integration is defined');
      return config.firebase.projectId;
    } // NOTE BRN: The max length of a project id is 30 characters


    return (0, _lang.slice)(0, 30, "test-".concat(config.test.runId));
  } // NOTE BRN: We couldn't do this because the emulator requires that the
  // projectId match the actual project in order to show data
  // if (config.stage === 'local') {
  //   return 'local'
  // }


  (0, _lang.invariant)(config.firebase.projectId, 'config.firebase.projectId must be defined');
  return config.firebase.projectId;
};

var _default = generateProjectId;
exports.default = _default;
//# sourceMappingURL=generateProjectId.js.map