"use strict";

require("core-js/modules/es.promise");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("regenerator-runtime/runtime");

var _lang = require("../lang");

var _evaluateConfigAndEnv2 = _interopRequireDefault(require("./util/evaluateConfigAndEnv"));

var _getStage = _interopRequireDefault(require("./util/getStage"));

var _getTarget = _interopRequireDefault(require("./util/getTarget"));

var _updateEnv = _interopRequireDefault(require("./util/updateEnv"));

var _validateConfig = _interopRequireDefault(require("./util/validateConfig"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var loadConfig = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(options = {}, initialConfig = {}, context = {}) {
    var stage, target, config, env, _require, loadConfigFile, loadDotEnv, cwd, _evaluateConfigAndEnv, modules;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            stage = (0, _getStage.default)(options);
            target = (0, _getTarget.default)(options);
            initialConfig = (0, _lang.merge)({
              stage,
              target
            }, initialConfig);

            if (!(target === 'web')) {
              _context.next = 8;
              break;
            }

            // NOTE BRN: We can't use fs here to load files and we shouldn't load the yaml
            // files in because they have sensitive data. Instead the config should be
            // precompiled and then injected into process.env
            config = process.env.MOLTRES_CONFIG ? JSON.parse(process.env.MOLTRES_CONFIG) : {};
            env = process.env.MOLTRES_ENV ? JSON.parse(process.env.MOLTRES_ENV) : {}; // NOTE BRN: We do not need to evaluate this config because it should have
            // already been evaluated at webpack time.

            _context.next = 19;
            break;

          case 8:
            // NOTE BRN: dynamically require the needed modules here so that we avoid
            // loading node specific modules in the web environment
            _require = require('./util'), loadConfigFile = _require.loadConfigFile, loadDotEnv = _require.loadDotEnv;
            _context.next = 11;
            return loadDotEnv(options);

          case 11:
            env = _context.sent;
            _context.next = 14;
            return loadConfigFile(options);

          case 14:
            config = _context.sent;
            cwd = options.cwd || process.cwd();
            _evaluateConfigAndEnv = (0, _evaluateConfigAndEnv2.default)({
              config: (0, _lang.mergeDeepRight)(initialConfig, config || {}),
              env
            }, options, (0, _lang.mergeDeepRight)({
              project: {
                dir: cwd
              }
            }, context));
            config = _evaluateConfigAndEnv.config;
            env = _evaluateConfigAndEnv.env;

          case 19:
            modules = options.modules;

            if (modules) {
              (0, _validateConfig.default)(modules, config);
            }

            if (target !== 'web') {
              (0, _updateEnv.default)(env);
            }

            return _context.abrupt("return", config);

          case 23:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function loadConfig() {
    return _ref.apply(this, arguments);
  };
}();

var _default = loadConfig;
exports.default = _default;
//# sourceMappingURL=loadConfig.js.map