"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _findConfigFileAtPathSync = _interopRequireDefault(require("./findConfigFileAtPathSync"));

var _getStage = _interopRequireDefault(require("./getStage"));

var _readConfigFileSync = _interopRequireDefault(require("./readConfigFileSync"));

var _resolveStagePath = _interopRequireDefault(require("./resolveStagePath"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var loadConfigFileSync = options => {
  var absoluteStagePath = (0, _resolveStagePath.default)(options);
  var configFilePath = (0, _findConfigFileAtPathSync.default)(absoluteStagePath);

  if (!configFilePath) {
    // eslint-disable-next-line no-console
    console.log("could not find config file for stage '".concat((0, _getStage.default)(options), "'"));
    return undefined;
  }

  return (0, _readConfigFileSync.default)(configFilePath);
};

var _default = loadConfigFileSync;
exports.default = _default;
//# sourceMappingURL=loadConfigFileSync.js.map