"use strict";

require("core-js/modules/es.array.includes");

require("core-js/modules/es.promise");

require("core-js/modules/es.string.includes");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("regenerator-runtime/runtime");

var _dotenv = _interopRequireDefault(require("dotenv"));

var _fs = require("../../fs");

var _lang = require("../../lang");

var _path = require("../../path");

var _resolveStagePath = _interopRequireDefault(require("./resolveStagePath"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var FILE_NAME_ENV = '.env';
var loadDotEnv = (0, _lang.defn)('loadDotEnv', /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(options) {
    var envFilePath, loadedEnv, data, values;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            envFilePath = (0, _path.pathResolve)((0, _resolveStagePath.default)(options), FILE_NAME_ENV);
            loadedEnv = {};
            _context.prev = 2;
            _context.next = 5;
            return (0, _fs.readFile)(envFilePath, 'utf8');

          case 5:
            data = _context.sent;
            values = _dotenv.default.parse(data);
            loadedEnv = values;
            _context.next = 14;
            break;

          case 10:
            _context.prev = 10;
            _context.t0 = _context["catch"](2);

            if (_context.t0.message.includes('ENOENT')) {
              _context.next = 14;
              break;
            }

            throw _context.t0;

          case 14:
            return _context.abrupt("return", loadedEnv);

          case 15:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[2, 10]]);
  }));

  return function (_x) {
    return _ref.apply(this, arguments);
  };
}());
var _default = loadDotEnv;
exports.default = _default;
//# sourceMappingURL=loadDotEnv.js.map