"use strict";

require("core-js/modules/es.array.includes");

require("core-js/modules/es.string.includes");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _dotenv = _interopRequireDefault(require("dotenv"));

var _fs = require("../../fs");

var _lang = require("../../lang");

var _path = require("../../path");

var _resolveStagePath = _interopRequireDefault(require("./resolveStagePath"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FILE_NAME_ENV = '.env';
var loadDotEnvSync = (0, _lang.defn)('loadDotEnvSync', options => {
  var envFilePath = (0, _path.pathResolve)((0, _resolveStagePath.default)(options), FILE_NAME_ENV);
  var loadedEnv = {};

  try {
    var data = (0, _fs.readFileSync)(envFilePath, 'utf8');

    var values = _dotenv.default.parse(data);

    loadedEnv = values;
  } catch (error) {
    if (!error.message.includes('ENOENT')) {
      throw error;
    }
  }

  return loadedEnv;
});
var _default = loadDotEnvSync;
exports.default = _default;
//# sourceMappingURL=loadDotEnvSync.js.map