"use strict";

require("core-js/modules/es.array.concat");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _error = require("../../error");

var _Symbol = require("../constants/Symbol");

var _evaluateVariableString = _interopRequireDefault(require("./evaluateVariableString"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var expectedBadVariableEvaluation = (variable, evalError) => (0, _error.expected)({
  causes: [evalError],
  code: 'BadVariableEvaluation',
  data: {
    error: evalError,
    variable
  },
  message: "An error occurred while evaluating the variable '".concat(variable.variableString, "'.\n\n\"").concat(evalError.message, "\"\n\n")
});

var newVariable = variableString => {
  var variable = {
    [_Symbol.VARIABLE]: true,

    evaluate(data, context) {
      try {
        return (0, _evaluateVariableString.default)(variableString, data, context);
      } catch (error) {
        throw expectedBadVariableEvaluation(variable, error);
      }
    },

    variableString
  };
  return variable;
};

var _default = newVariable;
exports.default = _default;
//# sourceMappingURL=newVariable.js.map