"use strict";

require("core-js/modules/es.regexp.to-string");

require("core-js/modules/es.string.trim");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _jsYaml = _interopRequireDefault(require("js-yaml"));

var _lang = require("../../lang");

var _path = require("../../path");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var parseConfigFile = (0, _lang.curry)((filePath, contents, options = {}) => {
  if ((0, _path.isJsonPath)(filePath)) {
    return JSON.parse(contents);
  } else if ((0, _path.isYamlPath)(filePath)) {
    return _jsYaml.default.load(contents.toString(), (0, _lang.merge)(options, {
      filename: filePath
    }));
  }

  return contents.toString().trim();
});
var _default = parseConfigFile;
exports.default = _default;
//# sourceMappingURL=parseConfigFile.js.map