"use strict";

require("core-js/modules/es.array.concat");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _error = require("../../error");

var _lang = require("../../lang");

var _schema = require("../../schema");

var validateConfig = (modules, config) => {
  (0, _lang.forEach)((mod, name) => {
    if (mod.configSchema) {
      try {
        (0, _schema.validateSchema)(mod.configSchema, (0, _lang.getProperty)(name, config));
      } catch (error) {
        // TOOD BRN: Use schema.describe to convert this into a more useful
        // error message that displays the expected shape of the config for this
        // module...
        // console.log(
        //   '(mod.configSchema.schema.describe():',
        //   mod.configSchema.schema.describe()
        // )
        throw (0, _error.expected)({
          code: 'ConfigMissing',
          data: (0, _lang.getProperty)(name, config),
          message: "Config missing for module '".concat(name, "'. ").concat(error.message)
        });
      }
    }
  }, modules);
};

var _default = validateConfig;
exports.default = _default;
//# sourceMappingURL=validateConfig.js.map