"use strict";

require("core-js/modules/es.array.filter");

require("core-js/modules/es.object.get-own-property-descriptors");

require("core-js/modules/es.promise");

require("core-js/modules/web.dom-collections.for-each");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("regenerator-runtime/runtime");

var _lang = require("../lang");

var _addTimestamps = _interopRequireDefault(require("./addTimestamps"));

var _addUpdatedAtTimestamp = _interopRequireDefault(require("./addUpdatedAtTimestamp"));

var _cleanseData = _interopRequireDefault(require("./cleanseData"));

var _refDocumentById = _interopRequireDefault(require("./refDocumentById"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var batchSetDocument = (0, _lang.curry)( /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(Schema, context, batch, id, data, document) {
    var ref, prevData;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            ref = (0, _refDocumentById.default)(Schema, context, id);
            prevData = document.data();

            if (!document.exists) {
              data = (0, _addTimestamps.default)(context, (0, _cleanseData.default)(Schema, data));
            } else {
              data = (0, _addUpdatedAtTimestamp.default)(context, // TODO BRN: Update this copy to use the Entity schema description
              (0, _cleanseData.default)(Schema, _objectSpread({
                createdAt: prevData.createdAt,
                removedAt: prevData.removedAt,
                removedByEntityId: prevData.removedByEntityId,
                removedByEntityType: prevData.removedByEntityType
              }, data)));
            }

            batch.set(ref, data);
            return _context.abrupt("return", ref);

          case 5:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function (_x, _x2, _x3, _x4, _x5, _x6) {
    return _ref.apply(this, arguments);
  };
}());
var _default = batchSetDocument;
exports.default = _default;
//# sourceMappingURL=batchSetDocument.js.map