"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lang = require("../lang");

var _indexDoc = _interopRequireDefault(require("./indexDoc"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var batchSetIndexes = (0, _lang.curry)(({
  collectionName,
  indexes
}, context, batch, data, document) => {
  var prevData = document.data();
  return (0, _lang.map)(index => {
    var nextIndexRef = (0, _indexDoc.default)(context, collectionName, index, data);

    if (prevData) {
      var prevIndexRef = (0, _indexDoc.default)(context, collectionName, index, prevData);

      if (nextIndexRef.path !== prevIndexRef.path) {
        batch.delete(prevIndexRef);
        batch.set(nextIndexRef, {
          value: document.id
        });
      }
    } else {
      batch.set(nextIndexRef, {
        value: document.id
      });
    }

    return nextIndexRef;
  }, indexes || []);
});
var _default = batchSetIndexes;
exports.default = _default;
//# sourceMappingURL=batchSetIndexes.js.map