"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lang = require("../lang");

var _indexDoc = _interopRequireDefault(require("./indexDoc"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var batchUpdateIndexes = (0, _lang.curry)(({
  collectionName,
  indexes
}, context, batch, data, document) => {
  var prevData = document.data();
  return (0, _lang.map)(index => {
    var prevIndexRef = (0, _indexDoc.default)(context, collectionName, index, prevData);
    var nextIndexRef = (0, _indexDoc.default)(context, collectionName, index, data);

    if (nextIndexRef.path !== prevIndexRef.path) {
      batch.set(nextIndexRef, {
        value: document.id
      });
      batch.delete(prevIndexRef);
    }

    return nextIndexRef;
  }, indexes || []);
});
var _default = batchUpdateIndexes;
exports.default = _default;
//# sourceMappingURL=batchUpdateIndexes.js.map