"use strict";

require("core-js/modules/es.promise");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("regenerator-runtime/runtime");

var _Code = require("../constants/Code");

var _expected = _interopRequireDefault(require("../error/expected"));

var _isPermissionsError = _interopRequireDefault(require("./isPermissionsError"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var buildBatch = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(context, builder) {
    var database, batch;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            database = context.database;
            _context.prev = 1;
            batch = database.batch(); // NOTE BRN: Batches are mutable

            _context.next = 5;
            return builder(batch);

          case 5:
            return _context.abrupt("return", batch);

          case 8:
            _context.prev = 8;
            _context.t0 = _context["catch"](1);

            if (!(0, _isPermissionsError.default)(_context.t0)) {
              _context.next = 12;
              break;
            }

            throw (0, _expected.default)({
              causes: [_context.t0],
              code: _Code.ACCESS_DENIED,
              message: _context.t0.message
            });

          case 12:
            throw _context.t0;

          case 13:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[1, 8]]);
  }));

  return function buildBatch(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var _default = buildBatch;
exports.default = _default;
//# sourceMappingURL=buildBatch.js.map