"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lang = require("../lang");

var collection = (0, _lang.curry)((Schema, context, data = null) => {
  var database = context.database;
  var parentRef = context.parentRef;

  if (!Schema) {
    throw new Error('Schema must be defined');
  }

  if (!parentRef && Schema.parentSchema) {
    if (Schema.parentRefIdField) {
      if (!data || !data[Schema.parentRefIdField]) {
        throw new Error("data must contain the parentRefIdField ".concat(Schema.parentRefIdField));
      }

      var parentCollection = collection(Schema.parentSchema, context, data);
      parentRef = parentCollection.doc(data[Schema.parentRefIdField]);
    } else {
      return database.collectionGroup(Schema.collectionName);
    }
  }

  var targetRef = parentRef || database;
  return targetRef.collection(Schema.collectionName);
});
var _default = collection;
exports.default = _default;
//# sourceMappingURL=collection.js.map