"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lang = require("../lang");

var _fromDate = _interopRequireDefault(require("./fromDate"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var convertDataToFirebase = (0, _lang.curry)((context, data) => (0, _lang.map)(value => {
  if ((0, _lang.isArray)(value) || (0, _lang.isPlainObject)(value)) {
    return convertDataToFirebase(context, value);
  }

  if ((0, _lang.isObject)(value) && (0, _lang.isFunction)(value.toMillis)) {
    var firebase = context.firebase;
    return firebase.firestore.Timestamp.fromMillis(value.toMillis());
  }

  if ((0, _lang.isDate)(value)) {
    return (0, _fromDate.default)(context, value);
  }

  return value;
}, data));
var _default = convertDataToFirebase;
exports.default = _default;
//# sourceMappingURL=convertDataToFirebase.js.map