"use strict";

require("core-js/modules/es.promise");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("regenerator-runtime/runtime");

var _Code = require("../constants/Code");

var _expected = _interopRequireDefault(require("../error/expected"));

var _formatSnapshot = _interopRequireDefault(require("./formatSnapshot"));

var _isPermissionsError = _interopRequireDefault(require("./isPermissionsError"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var findAllFromQuery = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee({
    logger
  }, query, queryOptions = {}) {
    var snapshot;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (query) {
              _context.next = 2;
              break;
            }

            return _context.abrupt("return", {});

          case 2:
            _context.prev = 2;
            _context.next = 5;
            return query.get();

          case 5:
            snapshot = _context.sent;
            return _context.abrupt("return", (0, _formatSnapshot.default)(snapshot, queryOptions));

          case 9:
            _context.prev = 9;
            _context.t0 = _context["catch"](2);

            if (!(0, _isPermissionsError.default)(_context.t0)) {
              _context.next = 14;
              break;
            }

            if (process.env.NODE_ENV !== 'production') {
              logger.warn('Permissions error - returning null from query:', _context.t0);
            }

            throw (0, _expected.default)({
              causes: [_context.t0],
              code: _Code.ACCESS_DENIED,
              message: _context.t0.message
            });

          case 14:
            throw _context.t0;

          case 15:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[2, 9]]);
  }));

  return function findAllFromQuery(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var _default = findAllFromQuery;
exports.default = _default;
//# sourceMappingURL=findAllFromQuery.js.map