"use strict";

require("core-js/modules/es.promise");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("regenerator-runtime/runtime");

var _constants = require("../constants");

var _error = require("../error");

var _formatDocument = _interopRequireDefault(require("./formatDocument"));

var _isPermissionsError = _interopRequireDefault(require("./isPermissionsError"));

var _refGet = _interopRequireDefault(require("./refGet"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var findFromRef = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(context, ref, options = {}) {
    var logger, document;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            logger = context.logger;
            _context.prev = 1;
            _context.next = 4;
            return (0, _refGet.default)(context, ref);

          case 4:
            document = _context.sent;
            return _context.abrupt("return", (0, _formatDocument.default)(document, options));

          case 8:
            _context.prev = 8;
            _context.t0 = _context["catch"](1);

            if (!(0, _isPermissionsError.default)(_context.t0)) {
              _context.next = 13;
              break;
            }

            if (process.env.NODE_ENV !== 'production') {
              logger.warn('Permissions error - returning null from query:', _context.t0);
            }

            throw (0, _error.expected)({
              causes: [_context.t0],
              code: _constants.Code.ACCESS_DENIED,
              message: _context.t0.message,
              statusCode: _constants.StatusCode.ACCESS_DENIED
            });

          case 13:
            throw _context.t0;

          case 14:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[1, 8]]);
  }));

  return function findFromRef(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var _default = findFromRef;
exports.default = _default;
//# sourceMappingURL=findFromRef.js.map