"use strict";

require("core-js/modules/es.array.filter");

require("core-js/modules/es.object.get-own-property-descriptors");

require("core-js/modules/es.promise");

require("core-js/modules/web.dom-collections.for-each");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("regenerator-runtime/runtime");

var _Code = require("../constants/Code");

var _expected = _interopRequireDefault(require("../error/expected"));

var _formatSnapshot = _interopRequireDefault(require("./formatSnapshot"));

var _isPermissionsError = _interopRequireDefault(require("./isPermissionsError"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var getOneFromQuery = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee({
    logger
  }, query, options = {}) {
    var snapshot;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            _context.next = 3;
            return query.get();

          case 3:
            snapshot = _context.sent;

            if (!(options.disallowPendingWrites && snapshot.metadata.hasPendingWrites)) {
              _context.next = 6;
              break;
            }

            throw (0, _expected.default)({
              code: _Code.PENDING_WRITES,
              message: 'Writes to the DB for this record are still pending'
            });

          case 6:
            return _context.abrupt("return", (0, _formatSnapshot.default)(snapshot, _objectSpread(_objectSpread({}, options), {}, {
              getOne: true
            })));

          case 9:
            _context.prev = 9;
            _context.t0 = _context["catch"](0);

            if (!(0, _isPermissionsError.default)(_context.t0)) {
              _context.next = 14;
              break;
            }

            if (process.env.NODE_ENV !== 'production') {
              // TODO BRN: Pull logger from context to log this
              logger.warn('Permissions error:', _context.t0);
            }

            throw (0, _expected.default)({
              causes: [_context.t0],
              code: _Code.ACCESS_DENIED,
              message: _context.t0.message
            });

          case 14:
            throw _context.t0;

          case 15:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[0, 9]]);
  }));

  return function getOneFromQuery(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var _default = getOneFromQuery;
exports.default = _default;
//# sourceMappingURL=getOneFromQuery.js.map