"use strict";

require("core-js/modules/es.promise");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("regenerator-runtime/runtime");

var _lang = require("../lang");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var nextPage = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(builder, {
    cursor,
    limit
  }) {
    var ref;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            ref = builder({
              cursor,
              limit
            });
            return _context.abrupt("return", ref.get());

          case 2:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function nextPage(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var paginateQuery = /*#__PURE__*/function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(builder, iteratee, {
    limit = 10
  } = {}) {
    var done, cursor, query;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            done = false;

          case 1:
            if (done) {
              _context2.next = 11;
              break;
            }

            _context2.next = 4;
            return nextPage(builder, {
              cursor,
              limit
            });

          case 4:
            query = _context2.sent;
            _context2.next = 7;
            return (0, _lang.map)(iteratee, query.docs);

          case 7:
            cursor = query;

            if (query.docs.length >= limit) {
              cursor = (0, _lang.last)(query.docs);
            } else {
              done = true;
            }

            _context2.next = 1;
            break;

          case 11:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function paginateQuery(_x3, _x4) {
    return _ref2.apply(this, arguments);
  };
}();

var _default = paginateQuery;
exports.default = _default;
//# sourceMappingURL=paginateQuery.js.map