"use strict";

require("core-js/modules/es.promise");

require("core-js/modules/es.regexp.to-string");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("regenerator-runtime/runtime");

var _validateSchema = _interopRequireDefault(require("../schema/validateSchema"));

var _batchSetDocument = _interopRequireDefault(require("./batchSetDocument"));

var _batchSetIndexes = _interopRequireDefault(require("./batchSetIndexes"));

var _buildBatch = _interopRequireDefault(require("./buildBatch"));

var _cleanseData = _interopRequireDefault(require("./cleanseData"));

var _collection = _interopRequireDefault(require("./collection"));

var _commitBatch = _interopRequireDefault(require("./commitBatch"));

var _paginateCollection = _interopRequireDefault(require("./paginateCollection"));

var _refGet = _interopRequireDefault(require("./refGet"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var renameCollection = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(context, OldSchema, NewSchema) {
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return (0, _paginateCollection.default)(OldSchema, context, /*#__PURE__*/function () {
              var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(doc) {
                var value;
                return regeneratorRuntime.wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        value = doc.data();
                        _context2.next = 3;
                        return (0, _commitBatch.default)((0, _buildBatch.default)(context, /*#__PURE__*/function () {
                          var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(batch) {
                            var data, Collection, ref, document;
                            return regeneratorRuntime.wrap(function _callee$(_context) {
                              while (1) {
                                switch (_context.prev = _context.next) {
                                  case 0:
                                    data = (0, _validateSchema.default)(NewSchema, (0, _cleanseData.default)(NewSchema, value));
                                    Collection = (0, _collection.default)(NewSchema, context);
                                    ref = Collection.doc(doc.id.toString());
                                    _context.next = 5;
                                    return (0, _refGet.default)(context, ref);

                                  case 5:
                                    document = _context.sent;
                                    (0, _batchSetDocument.default)(NewSchema, context, batch, doc.id, data, document);
                                    (0, _batchSetIndexes.default)(NewSchema, context, batch, data, document);

                                  case 8:
                                  case "end":
                                    return _context.stop();
                                }
                              }
                            }, _callee);
                          }));

                          return function (_x5) {
                            return _ref3.apply(this, arguments);
                          };
                        }()));

                      case 3:
                      case "end":
                        return _context2.stop();
                    }
                  }
                }, _callee2);
              }));

              return function (_x4) {
                return _ref2.apply(this, arguments);
              };
            }());

          case 2:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));

  return function renameCollection(_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}();

var _default = renameCollection;
exports.default = _default;
//# sourceMappingURL=renameCollection.js.map