"use strict";

require("core-js/modules/es.array.concat");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _path = require("../path");

var _identicalPathStats = _interopRequireDefault(require("./identicalPathStats"));

var _util = require("./util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var checkParentPathsSync = (src, srcStat, dest, funcName) => {
  var srcParent = (0, _path.pathResolve)((0, _path.pathDirname)(src));
  var destParent = (0, _path.pathResolve)((0, _path.pathDirname)(dest));

  if (destParent === srcParent || destParent === (0, _path.pathParse)(destParent).root) {
    return;
  }

  var destStat;

  try {
    destStat = (0, _util.statSync)(destParent);
  } catch (err) {
    if (err.code === 'ENOENT') {
      return;
    }

    throw err;
  }

  if ((0, _identicalPathStats.default)(srcStat, destStat)) {
    throw new Error("Cannot ".concat(funcName, " '").concat(src, "' to a subdirectory of itself, '").concat(dest, "'."));
  }

  return checkParentPathsSync(src, srcStat, destParent, funcName);
};

var _default = checkParentPathsSync;
exports.default = _default;
//# sourceMappingURL=checkParentPathsSync.js.map