"use strict";

require("core-js/modules/es.array.concat");

require("core-js/modules/es.promise");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("regenerator-runtime/runtime");

var _lang = require("../lang");

var _path = require("../path");

var _identicalPathStats = _interopRequireDefault(require("./identicalPathStats"));

var _util = require("./util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var bigIntStat = file => (0, _util.stat)(file, {
  bigint: true
});

var getStats = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(src, dest) {
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            return _context.abrupt("return", (0, _lang.all)({
              destStat: bigIntStat(dest).catch(err => {
                if (err.code === 'ENOENT') {
                  return null;
                }

                throw err;
              }),
              srcStat: bigIntStat(src)
            }));

          case 1:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function getStats(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var checkPaths = /*#__PURE__*/function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(src, dest, funcName) {
    var _yield$getStats, destStat, srcStat;

    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return getStats(src, dest);

          case 2:
            _yield$getStats = _context2.sent;
            destStat = _yield$getStats.destStat;
            srcStat = _yield$getStats.srcStat;

            if (!(destStat && (0, _identicalPathStats.default)(srcStat, destStat))) {
              _context2.next = 7;
              break;
            }

            throw new Error('Source and destination must not be the same.');

          case 7:
            if (!(srcStat.isDirectory() && (0, _path.isPathSubdir)(src, dest))) {
              _context2.next = 9;
              break;
            }

            throw new Error("Cannot ".concat(funcName, " '").concat(src, "' to a subdirectory of itself, '").concat(dest, "'."));

          case 9:
            return _context2.abrupt("return", {
              destStat,
              srcStat
            });

          case 10:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function checkPaths(_x3, _x4, _x5) {
    return _ref2.apply(this, arguments);
  };
}();

var _default = checkPaths;
exports.default = _default;
//# sourceMappingURL=checkPaths.js.map