"use strict";

require("core-js/modules/es.array.filter");

require("core-js/modules/es.object.get-own-property-descriptors");

require("core-js/modules/es.promise");

require("core-js/modules/web.dom-collections.for-each");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("regenerator-runtime/runtime");

var _path = require("../path");

var _checkPaths = _interopRequireDefault(require("./checkPaths"));

var _util = require("./util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var copyDirectoryItem = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(items, item, src, dest, options, context) {
    var srcItem, destItem, _yield$checkPaths, destStat;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            srcItem = (0, _path.pathJoin)(src, item);
            destItem = (0, _path.pathJoin)(dest, item);
            _context.next = 4;
            return (0, _checkPaths.default)(srcItem, destItem, 'copy');

          case 4:
            _yield$checkPaths = _context.sent;
            destStat = _yield$checkPaths.destStat;
            _context.next = 8;
            return (0, _util.startCopy)(destStat, srcItem, destItem, options, context);

          case 8:
            return _context.abrupt("return", context.copyDirectoryItems(items, src, dest, options));

          case 9:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function copyDirectoryItem(_x, _x2, _x3, _x4, _x5, _x6) {
    return _ref.apply(this, arguments);
  };
}();

var copyDirectoryItems = /*#__PURE__*/function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(items, src, dest, options, context) {
    var item;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            item = items.pop();

            if (item) {
              _context2.next = 3;
              break;
            }

            return _context2.abrupt("return");

          case 3:
            return _context2.abrupt("return", copyDirectoryItem(items, item, src, dest, options, _objectSpread(_objectSpread({}, context), {}, {
              copyDirectoryItems
            })));

          case 4:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function copyDirectoryItems(_x7, _x8, _x9, _x10, _x11) {
    return _ref2.apply(this, arguments);
  };
}();

var copyDirectory = /*#__PURE__*/function () {
  var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(src, dest, options) {
    var items;
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return (0, _util.readdir)(src);

          case 2:
            items = _context3.sent;
            return _context3.abrupt("return", copyDirectoryItems(items, src, dest, options, {
              copyDirectory
            }));

          case 4:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));

  return function copyDirectory(_x12, _x13, _x14) {
    return _ref3.apply(this, arguments);
  };
}();

var _default = copyDirectory;
exports.default = _default;
//# sourceMappingURL=copyDirectory.js.map