"use strict";

require("core-js/modules/es.promise");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("regenerator-runtime/runtime");

var _fileUtimesMillis = _interopRequireDefault(require("./fileUtimesMillis"));

var _util = require("./util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var fileIsNotWritable = srcMode => (srcMode & 0o200) === 0;

var makeFileWritable = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(dest, srcMode) {
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            return _context.abrupt("return", (0, _util.chmod)(dest, srcMode | 0o200));

          case 1:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function makeFileWritable(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var setDestTimestamps = /*#__PURE__*/function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(src, dest) {
    var updatedSrcStat;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return (0, _util.stat)(src);

          case 2:
            updatedSrcStat = _context2.sent;
            return _context2.abrupt("return", (0, _fileUtimesMillis.default)(dest, updatedSrcStat.atime, updatedSrcStat.mtime));

          case 4:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function setDestTimestamps(_x3, _x4) {
    return _ref2.apply(this, arguments);
  };
}();

var setDestTimestampsAndMode = /*#__PURE__*/function () {
  var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(srcMode, src, dest) {
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return setDestTimestamps(src, dest);

          case 2:
            return _context3.abrupt("return", (0, _util.chmod)(dest, srcMode));

          case 3:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));

  return function setDestTimestampsAndMode(_x5, _x6, _x7) {
    return _ref3.apply(this, arguments);
  };
}();

var handleTimestampsAndMode = /*#__PURE__*/function () {
  var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(srcMode, src, dest) {
    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            if (!fileIsNotWritable(srcMode)) {
              _context4.next = 3;
              break;
            }

            _context4.next = 3;
            return makeFileWritable(dest, srcMode);

          case 3:
            return _context4.abrupt("return", setDestTimestampsAndMode(srcMode, src, dest));

          case 4:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));

  return function handleTimestampsAndMode(_x8, _x9, _x10) {
    return _ref4.apply(this, arguments);
  };
}();

var copyFile = /*#__PURE__*/function () {
  var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(srcStat, src, dest, options) {
    return regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return (0, _util.copyFile)(src, dest);

          case 2:
            if (!options.preserveTimestamps) {
              _context5.next = 4;
              break;
            }

            return _context5.abrupt("return", handleTimestampsAndMode(srcStat.mode, src, dest));

          case 4:
            return _context5.abrupt("return", (0, _util.chmod)(dest, srcStat.mode));

          case 5:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  }));

  return function copyFile(_x11, _x12, _x13, _x14) {
    return _ref5.apply(this, arguments);
  };
}();

var _default = copyFile;
exports.default = _default;
//# sourceMappingURL=copyFile.js.map