"use strict";

require("core-js/modules/es.array.concat");

require("core-js/modules/es.array.filter");

require("core-js/modules/es.promise");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("regenerator-runtime/runtime");

var _lang = require("../lang");

var _path = require("../path");

var _checkParentPaths = _interopRequireDefault(require("./checkParentPaths"));

var _checkPaths = _interopRequireDefault(require("./checkPaths"));

var _copyDirectory = _interopRequireDefault(require("./copyDirectory"));

var _copyLink = _interopRequireDefault(require("./copyLink"));

var _ensureDirectory = _interopRequireDefault(require("./ensureDirectory"));

var _pathExists = _interopRequireDefault(require("./pathExists"));

var _util = require("./util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var mayCopyFile = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(srcStat, src, dest, options) {
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!options.overwrite) {
              _context.next = 6;
              break;
            }

            _context.next = 3;
            return (0, _util.unlink)(dest);

          case 3:
            return _context.abrupt("return", (0, _util.copyFile)(srcStat, src, dest, options));

          case 6:
            if (!options.errorOnExist) {
              _context.next = 8;
              break;
            }

            throw new Error("'".concat(dest, "' already exists"));

          case 8:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function mayCopyFile(_x, _x2, _x3, _x4) {
    return _ref.apply(this, arguments);
  };
}();

var mkDirAndCopy = /*#__PURE__*/function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(srcMode, src, dest, options) {
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return (0, _util.mkdir)(dest);

          case 2:
            _context2.next = 4;
            return (0, _copyDirectory.default)(src, dest, options);

          case 4:
            return _context2.abrupt("return", (0, _util.chmod)(dest, srcMode));

          case 5:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function mkDirAndCopy(_x5, _x6, _x7, _x8) {
    return _ref2.apply(this, arguments);
  };
}();

var getStats = /*#__PURE__*/function () {
  var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(destStat, src, dest, options) {
    var srcStat, resolvedSrc, resolvedDest;
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            if (!options.dereference) {
              _context3.next = 6;
              break;
            }

            _context3.next = 3;
            return (0, _util.stat)(src);

          case 3:
            srcStat = _context3.sent;
            _context3.next = 9;
            break;

          case 6:
            _context3.next = 8;
            return _util.lstat;

          case 8:
            srcStat = _context3.sent;

          case 9:
            if (!srcStat.isDirectory()) {
              _context3.next = 17;
              break;
            }

            if (destStat) {
              _context3.next = 12;
              break;
            }

            return _context3.abrupt("return", mkDirAndCopy(srcStat.mode, src, dest, options));

          case 12:
            if (!(destStat && !destStat.isDirectory())) {
              _context3.next = 14;
              break;
            }

            throw new Error("Cannot overwrite non-directory '".concat(dest, "' with directory '").concat(src, "'."));

          case 14:
            return _context3.abrupt("return", (0, _copyDirectory.default)(src, dest, options));

          case 17:
            if (!(srcStat.isFile() || srcStat.isCharacterDevice() || srcStat.isBlockDevice())) {
              _context3.next = 23;
              break;
            }

            if (destStat) {
              _context3.next = 20;
              break;
            }

            return _context3.abrupt("return", (0, _util.copyFile)(srcStat, src, dest, options));

          case 20:
            return _context3.abrupt("return", mayCopyFile(srcStat, src, dest, options));

          case 23:
            if (!srcStat.isSymbolicLink()) {
              _context3.next = 47;
              break;
            }

            _context3.next = 26;
            return (0, _util.readlink)(src);

          case 26:
            resolvedSrc = _context3.sent;

            if (options.dereference) {
              resolvedSrc = (0, _path.pathResolve)(process.cwd(), resolvedSrc);
            }

            if (destStat) {
              _context3.next = 30;
              break;
            }

            return _context3.abrupt("return", (0, _util.symlink)(resolvedSrc, dest));

          case 30:
            _context3.prev = 30;
            _context3.next = 33;
            return (0, _util.readlink)(dest);

          case 33:
            resolvedDest = _context3.sent;

            if (options.dereference) {
              resolvedDest = (0, _path.pathResolve)(process.cwd(), resolvedDest);
            }

            if (!(0, _path.isPathSubdir)(resolvedSrc, resolvedDest)) {
              _context3.next = 37;
              break;
            }

            throw new Error("Cannot copy '".concat(resolvedSrc, "' to a subdirectory of itself, '").concat(resolvedDest, "'."));

          case 37:
            if (!(destStat.isDirectory() && (0, _path.isPathSubdir)(resolvedDest, resolvedSrc))) {
              _context3.next = 39;
              break;
            }

            throw new Error("Cannot overwrite '".concat(resolvedDest, "' with '").concat(resolvedSrc, "'."));

          case 39:
            return _context3.abrupt("return", (0, _copyLink.default)(resolvedSrc, dest));

          case 42:
            _context3.prev = 42;
            _context3.t0 = _context3["catch"](30);

            if (!(_context3.t0.code === 'EINVAL' || _context3.t0.code === 'UNKNOWN')) {
              _context3.next = 46;
              break;
            }

            return _context3.abrupt("return", (0, _util.symlink)(resolvedSrc, dest));

          case 46:
            throw _context3.t0;

          case 47:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3, null, [[30, 42]]);
  }));

  return function getStats(_x9, _x10, _x11, _x12) {
    return _ref3.apply(this, arguments);
  };
}();

var startCopy = /*#__PURE__*/function () {
  var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(destStat, src, dest, options) {
    var include;
    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            if (!options.filter) {
              _context4.next = 6;
              break;
            }

            _context4.next = 3;
            return options.filter(src, dest);

          case 3:
            include = _context4.sent;

            if (include) {
              _context4.next = 6;
              break;
            }

            return _context4.abrupt("return");

          case 6:
            return _context4.abrupt("return", getStats(destStat, src, dest, options));

          case 7:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));

  return function startCopy(_x13, _x14, _x15, _x16) {
    return _ref4.apply(this, arguments);
  };
}();

var checkParentDir = /*#__PURE__*/function () {
  var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(destStat, src, dest, options) {
    var destParent, dirExists;
    return regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            destParent = (0, _path.pathDirname)(dest);
            _context5.next = 3;
            return (0, _pathExists.default)(destParent);

          case 3:
            dirExists = _context5.sent;

            if (dirExists) {
              _context5.next = 7;
              break;
            }

            _context5.next = 7;
            return (0, _ensureDirectory.default)(destParent);

          case 7:
            return _context5.abrupt("return", startCopy(destStat, src, dest, options));

          case 8:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  }));

  return function checkParentDir(_x17, _x18, _x19, _x20) {
    return _ref5.apply(this, arguments);
  };
}();

var copyPath = /*#__PURE__*/function () {
  var _ref6 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6(src, dest, options = {}) {
    var _yield$checkPaths, destStat, srcStat, include;

    return regeneratorRuntime.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            if ((0, _lang.isFunction)(options)) {
              options = {
                filter: options
              };
            }

            options.clobber = (0, _lang.defaultTo)(true, options.clobber); // default to true for now

            options.overwrite = (0, _lang.defaultTo)(options.clobber, options.overwrite); // overwrite falls back to clobber
            // Warn about using preserveTimestamps on 32-bit node

            if (options.preserveTimestamps && process.arch === 'ia32') {
              // eslint-disable-next-line no-console
              console.warn("fs-extra: Using the preserveTimestamps option in 32-bit node is not recommended;\n\n    see https://github.com/jprichardson/node-fs-extra/issues/269");
            }

            _context6.next = 6;
            return (0, _checkPaths.default)(src, dest, 'copy');

          case 6:
            _yield$checkPaths = _context6.sent;
            destStat = _yield$checkPaths.destStat;
            srcStat = _yield$checkPaths.srcStat;
            _context6.next = 11;
            return (0, _checkParentPaths.default)(src, srcStat, dest, 'copy');

          case 11:
            if (!options.filter) {
              _context6.next = 17;
              break;
            }

            _context6.next = 14;
            return options.filter(src, dest);

          case 14:
            include = _context6.sent;

            if (include) {
              _context6.next = 17;
              break;
            }

            return _context6.abrupt("return");

          case 17:
            return _context6.abrupt("return", checkParentDir(destStat, src, dest, options));

          case 18:
          case "end":
            return _context6.stop();
        }
      }
    }, _callee6);
  }));

  return function copyPath(_x21, _x22) {
    return _ref6.apply(this, arguments);
  };
}();

var _default = copyPath;
exports.default = _default;
//# sourceMappingURL=copyPath.js.map