"use strict";

require("core-js/modules/es.promise");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("regenerator-runtime/runtime");

var _path = require("../path");

var _ensureDirectory = _interopRequireDefault(require("./ensureDirectory"));

var _util = require("./util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var createFile = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(file) {
    var stats, dir;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            _context.next = 3;
            return (0, _util.stat)(file);

          case 3:
            stats = _context.sent;
            _context.next = 8;
            break;

          case 6:
            _context.prev = 6;
            _context.t0 = _context["catch"](0);

          case 8:
            if (!(stats && stats.isFile())) {
              _context.next = 10;
              break;
            }

            return _context.abrupt("return");

          case 10:
            dir = (0, _path.pathDirname)(file);
            _context.prev = 11;
            _context.next = 14;
            return (0, _util.stat)(dir);

          case 14:
            stats = _context.sent;

            if (stats.isDirectory()) {
              _context.next = 18;
              break;
            }

            _context.next = 18;
            return (0, _util.readdir)(dir);

          case 18:
            _context.next = 28;
            break;

          case 20:
            _context.prev = 20;
            _context.t1 = _context["catch"](11);

            if (!(_context.t1 && _context.t1.code === 'ENOENT')) {
              _context.next = 27;
              break;
            }

            _context.next = 25;
            return (0, _ensureDirectory.default)(dir);

          case 25:
            _context.next = 28;
            break;

          case 27:
            throw _context.t1;

          case 28:
            return _context.abrupt("return", (0, _util.writeFile)(file, ''));

          case 29:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[0, 6], [11, 20]]);
  }));

  return function createFile(_x) {
    return _ref.apply(this, arguments);
  };
}();

var _default = createFile;
exports.default = _default;
//# sourceMappingURL=createFile.js.map