"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _path = require("../path");

var _ensureDirectorySync = _interopRequireDefault(require("./ensureDirectorySync"));

var _util = require("./util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var createFileSync = file => {
  var stats;

  try {
    stats = (0, _util.statSync)(file);
  } catch (_unused) {}

  if (stats && stats.isFile()) {
    return;
  }

  var dir = (0, _path.pathDirname)(file);

  try {
    if (!(0, _util.statSync)(dir).isDirectory()) {
      // parent is not a directory
      // This is just to cause an internal ENOTDIR error to be thrown
      (0, _util.readdirSync)(dir);
    }
  } catch (error) {
    // If the stat call above failed because the directory doesn't exist, create it
    if (error && error.code === 'ENOENT') {
      (0, _ensureDirectorySync.default)(dir);
    } else {
      throw error;
    }
  }

  (0, _util.writeFileSync)(file, '');
};

var _default = createFileSync;
exports.default = _default;
//# sourceMappingURL=createFileSync.js.map