"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classes = require("./classes");

var _curry = _interopRequireDefault(require("./curry"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Converts two values into Numbers and then adds them together.
 *
 * @function
 * @since v0.6.0
 * @category lang
 * @param {*} valueA The first value
 * @param {*} valueB the second value to add to the first
 * @returns {Number} The sum of valueA and valueB
 * @example
 *
 * add(2, 3)
 * //=>  5
 *
 * add(7)(10)
 * //=> 17
 *
 * add(2.2, 3.2)
 * // => 5.4
 *
 * add('2', '3')
 * // => 5
 */
var add = (0, _curry.default)((valueA, valueB) => (0, _classes.Number)(valueA) + (0, _classes.Number)(valueB));
var _default = add;
exports.default = _default;
//# sourceMappingURL=add.js.map