"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _curry = _interopRequireDefault(require("./curry"));

var _isArray = _interopRequireDefault(require("./isArray"));

var _isString = _interopRequireDefault(require("./isString"));

var _satisfiesIndexed = _interopRequireDefault(require("./satisfiesIndexed"));

var _util = require("./util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var assocIndex = (0, _curry.default)((index, value, collection) => {
  if (!(0, _satisfiesIndexed.default)(collection)) {
    throw new Error("collection must be an Indexed value. Instead was given ".concat(collection));
  }

  if ((0, _isArray.default)(collection)) {
    return (0, _util.arraySetIndex)(collection, index, value);
  }

  if ((0, _isString.default)(collection)) {
    return (0, _util.stringSetIndex)(collection, index, value);
  }

  return collection.set(index, value);
});
var _default = assocIndex;
exports.default = _default;
//# sourceMappingURL=assocIndex.js.map