"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _curry = _interopRequireDefault(require("./curry"));

var _isMap = _interopRequireDefault(require("./isMap"));

var _satisfiesKeyed = _interopRequireDefault(require("./satisfiesKeyed"));

var _util = require("./util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var assocKey = (0, _curry.default)((selector, value, collection) => {
  if (!(0, _satisfiesKeyed.default)(collection)) {
    throw new Error("collection must be a Keyed value. Instead was given ".concat(collection));
  }

  if ((0, _isMap.default)(collection)) {
    return (0, _util.mapSetKey)(collection, selector, value);
  }

  return collection.set(selector, value);
});
var _default = assocKey;
exports.default = _default;
//# sourceMappingURL=assocKey.js.map