"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _assoc = _interopRequireDefault(require("./assoc"));

var _ImmutableList = _interopRequireDefault(require("./classes/ImmutableList"));

var _ImmutableMap = _interopRequireDefault(require("./classes/ImmutableMap"));

var _createPath = _interopRequireDefault(require("./createPath"));

var _first = _interopRequireDefault(require("./first"));

var _getProperty = _interopRequireDefault(require("./getProperty"));

var _hasProperty = _interopRequireDefault(require("./hasProperty"));

var _isImmutable = _interopRequireDefault(require("./isImmutable"));

var _isInteger = _interopRequireDefault(require("./isInteger"));

var _isNil = _interopRequireDefault(require("./isNil"));

var _isObject = _interopRequireDefault(require("./isObject"));

var _isPath = _interopRequireDefault(require("./isPath"));

var _isString = _interopRequireDefault(require("./isString"));

var _size = _interopRequireDefault(require("./size"));

var _slice = _interopRequireDefault(require("./slice"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getNextCollection = (collection, part, parts) => {
  if (part === '$') {
    return collection;
  }

  if (!(0, _isNil.default)(collection) && (0, _hasProperty.default)(part, collection) && (0, _isObject.default)((0, _getProperty.default)(part, collection))) {
    return (0, _getProperty.default)(part, collection);
  }

  if ((0, _isNil.default)(collection)) {
    return {};
  }

  if ((0, _isInteger.default)((0, _getProperty.default)(1, parts))) {
    if ((0, _isImmutable.default)(collection)) {
      return new _ImmutableList.default();
    }

    return [];
  }

  if ((0, _isImmutable.default)(collection)) {
    return new _ImmutableMap.default();
  }

  return {};
};

var assocPath = (path, value, collection) => {
  if ((0, _isString.default)(path)) {
    path = (0, _createPath.default)(path);
  }

  if (!(0, _isPath.default)(path)) {
    throw new TypeError("setPath expected 'path' parameter to be a Path. Instead received ".concat(path));
  }

  if ((0, _size.default)(path) === 0) {
    return value;
  }

  var part = (0, _first.default)(path);

  if ((0, _size.default)(path) > 1) {
    var nextCollection = getNextCollection(collection, part, path);
    value = assocPath((0, _slice.default)(1, Infinity, path), value, nextCollection);
  }

  if (part === '$') {
    return value;
  }

  return (0, _assoc.default)(part, value, collection);
};

var _default = assocPath;
exports.default = _default;
//# sourceMappingURL=assocPath.js.map