"use strict";

require("core-js/modules/es.array.iterator");

require("core-js/modules/web.dom-collections.iterator");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _Symbol = require("../constants/Symbol");

var _anyToImmutableList = _interopRequireDefault(require("../util/anyToImmutableList"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Note: This class is **immutable**
 *
 * This class represents a Path of one or more Propeties, Keys and Indexes
 *
 * @private
 * @class
 * @category lang.classes
 * @since v0.1.0
 */
class Path {
  constructor(path) {
    this.path = (0, _anyToImmutableList.default)(path);
    this.size = this.path.size;
  }

  [_Symbol.ITERATOR]() {
    return this.path.values();
  }

  get [_Symbol.TO_STRING_TAG]() {
    return 'Path';
  }

  first() {
    return this.get(0);
  }

  get(index) {
    return this.path.get(index);
  }

  rest() {
    return this.tail();
  }

  tail() {
    return new Path(this.path.rest());
  }

  toName() {
    return this.path.join('.');
  }

}

var _default = Path;
exports.default = _default;
//# sourceMappingURL=Path.js.map