"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defn = _interopRequireDefault(require("./defn"));

var _isNil = _interopRequireDefault(require("./isNil"));

var _reject = _interopRequireDefault(require("./reject"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Creates an array with all nil values removed.
 *
 * @function
 * @since v0.0.10
 * @category lang
 * @param {Array} array The array to compact.
 * @returns {Array} Returns the new array of filtered values.
 * @example
 *
 * compact([0, 1, false, 2, null, '', 3, undefined])
 * // => [0, 1, false, 2, null, '', 3]
 */
var compact = (0, _defn.default)('compact', (0, _reject.default)(_isNil.default));
var _default = compact;
exports.default = _default;
//# sourceMappingURL=compact.js.map