"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _ramda = require("ramda");

var _curry = _interopRequireDefault(require("./curry"));

var _isArray = _interopRequireDefault(require("./isArray"));

var _isImmutable = _interopRequireDefault(require("./isImmutable"));

var _reduce = _interopRequireDefault(require("./reduce"));

var _values = _interopRequireDefault(require("./values"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var concat2 = (value0, value1) => {
  if ((0, _isArray.default)(value0)) {
    if ((0, _isImmutable.default)(value1)) {
      return (0, _ramda.concat)(value0, (0, _values.default)(value1).toArray());
    }
  }

  return (0, _ramda.concat)(value0, value1);
};

var concat = (0, _curry.default)((arg0, arg1, ...args) => (0, _reduce.default)(concat2, concat2(arg0, arg1), args));
var _default = concat;
exports.default = _default;
//# sourceMappingURL=concat.js.map