"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MAX_SAFE = void 0;

var _Number = _interopRequireDefault(require("../classes/Number"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * This constant represents the maximum safe integer in JavaScript (2^53 - 1 or 9007199254740991).
 *
 * See [Number.MAX_SAFE_INTEGER](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Number/MAX_SAFE_INTEGER) for more information.
 *
 * @private
 * @type {number}
 * @since v0.1.0
 * @category lang.constants
 */
var MAX_SAFE = _Number.default.MAX_SAFE_INTEGER;
exports.MAX_SAFE = MAX_SAFE;
//# sourceMappingURL=Integer.js.map