"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MAX_VALUE = exports.INFINITY = void 0;

var _Infinity = _interopRequireDefault(require("../classes/Infinity"));

var _Number = _interopRequireDefault(require("../classes/Number"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * This constant represents the value Infinity in JavaScript `Infinity`
 *
 * See
 * [Infinity](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Infinity)
 * for more information.
 *
 * @private
 * @type {number}
 * @since v0.1.0
 * @category lang.constants
 */
var INFINITY = _Infinity.default;
/**
 * This constant property represents the maximum numeric value representable in JavaScript (1.7976931348623157e+308)
 *
 * See [Number.MAX_VALUE](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Number/MAX_VALUE) for more information.
 *
 * @private
 * @type {number}
 * @since v0.1.0
 * @category lang.constants
 */

exports.INFINITY = INFINITY;
var MAX_VALUE = _Number.default.MAX_VALUE;
exports.MAX_VALUE = MAX_VALUE;
//# sourceMappingURL=Number.js.map