"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _immutable = require("immutable");

var _classes = require("./classes");

var _isArray = _interopRequireDefault(require("./isArray"));

var _isImmutableList = _interopRequireDefault(require("./isImmutableList"));

var _isImmutableMap = _interopRequireDefault(require("./isImmutableMap"));

var _isIndex = _interopRequireDefault(require("./isIndex"));

var _isKey = _interopRequireDefault(require("./isKey"));

var _isObject = _interopRequireDefault(require("./isObject"));

var _isProperty = _interopRequireDefault(require("./isProperty"));

var _isString = _interopRequireDefault(require("./isString"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var contagion = (value, sample) => {
  if (!sample) {
    if ((0, _isArray.default)(value)) {
      return [];
    }

    if ((0, _isImmutableMap.default)(value)) {
      return new _classes.ImmutableMap({});
    }

    if ((0, _isImmutableList.default)(value)) {
      return new _classes.ImmutableList([]);
    }

    if ((0, _immutable.isImmutable)(value)) {
      throw new Error("This kind of Immutable value is not currently supported ".concat(value));
    }

    if ((0, _isObject.default)(value)) {
      return {};
    }

    if ((0, _isString.default)(value)) {
      return value;
    }

    throw new Error("unsupported value given to contagion function: ".concat(value));
  }

  if ((0, _isArray.default)(value)) {
    if ((0, _isIndex.default)(sample)) {
      return [];
    }

    if ((0, _isProperty.default)(sample)) {
      return {};
    }

    if ((0, _isKey.default)(sample)) {
      return new _classes.Map();
    }

    throw new Error("unsupported sample for Array value ".concat(sample));
  }

  if ((0, _isImmutableList.default)(value)) {
    if ((0, _isIndex.default)(sample)) {
      return (0, _classes.ImmutableList)([]);
    }

    if ((0, _isKey.default)(sample)) {
      return (0, _classes.ImmutableMap)();
    }

    throw new Error("unsupported sample for ImmutableList value ".concat(sample));
  }

  if ((0, _isImmutableMap.default)(value)) {
    if ((0, _isIndex.default)(sample)) {
      return (0, _classes.ImmutableList)([]);
    }

    if ((0, _isKey.default)(sample)) {
      return (0, _classes.ImmutableMap)();
    }

    throw new Error("unsupported sample for ImmutableMap value ".concat(sample));
  }

  if ((0, _isObject.default)(value)) {
    if ((0, _isIndex.default)(sample)) {
      return [];
    }

    if ((0, _isProperty.default)(sample)) {
      return {};
    }

    if ((0, _isKey.default)(sample)) {
      return new _classes.Map();
    }

    throw new Error("unsupported sample for ImmutableMap value ".concat(sample));
  }

  throw new Error("unsupported value given to contagion function: ".concat(value));
};

var _default = contagion;
exports.default = _default;
//# sourceMappingURL=contagion.js.map