"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _anyIsWildcard = _interopRequireDefault(require("./anyIsWildcard"));

var _createPath = _interopRequireDefault(require("./createPath"));

var _isArray = _interopRequireDefault(require("./isArray"));

var _isFunction = _interopRequireDefault(require("./isFunction"));

var _isImmutableList = _interopRequireDefault(require("./isImmutableList"));

var _isNil = _interopRequireDefault(require("./isNil"));

var _isString = _interopRequireDefault(require("./isString"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var containsWildcard = value => {
  if ((0, _isNil.default)(value)) {
    return false;
  }

  if ((0, _isFunction.default)(value.containsWildcard)) {
    return value.containsWildcard();
  }

  if ((0, _isArray.default)(value) || (0, _isImmutableList.default)(value)) {
    return (0, _anyIsWildcard.default)(value);
  }

  if ((0, _isString.default)(value)) {
    return (0, _anyIsWildcard.default)((0, _createPath.default)(value));
  }

  return false;
};

var _default = containsWildcard;
exports.default = _default;
//# sourceMappingURL=containsWildcard.js.map