"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _isIterable = _interopRequireDefault(require("./isIterable"));

var _isString = _interopRequireDefault(require("./isString"));

var _isSymbol = _interopRequireDefault(require("./isSymbol"));

var _toArray = _interopRequireDefault(require("./toArray"));

var _toPath = _interopRequireDefault(require("./toPath"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var createPath = value => {
  if ((0, _isString.default)(value)) {
    return (0, _toPath.default)(value);
  }

  if ((0, _isIterable.default)(value)) {
    return (0, _toPath.default)((0, _toArray.default)(value));
  }

  if ((0, _isSymbol.default)(value)) {
    return (0, _toPath.default)([value]);
  }

  throw new Error("cannot convert the given value into a Path ".concat(value));
};

var _default = createPath;
exports.default = _default;
//# sourceMappingURL=createPath.js.map