"use strict";

require("core-js/modules/es.array.iterator");

require("core-js/modules/web.dom-collections.iterator");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _any = _interopRequireDefault(require("./any"));

var _classes = require("./classes");

var _containsWildcard2 = _interopRequireDefault(require("./containsWildcard"));

var _findWildcards2 = _interopRequireDefault(require("./findWildcards"));

var _isArray = _interopRequireDefault(require("./isArray"));

var _map = _interopRequireDefault(require("./map"));

var _reduce = _interopRequireDefault(require("./reduce"));

var _replaceWildcards2 = _interopRequireDefault(require("./replaceWildcards"));

var _select2 = _interopRequireDefault(require("./select"));

var _weakMemoize = _interopRequireDefault(require("./weakMemoize"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SELECT_DEFAULT = () => {
  throw new Error('select for wildcard selector is currently not implemented');
};

var createSelector = (selectors, reducer) => {
  if (!(0, _isArray.default)(selectors)) {
    selectors = [selectors];
  }

  var containsWildcard = (0, _weakMemoize.default)(() => (0, _any.default)(_containsWildcard2.default, selectors));

  var findWildcards = (wildcards = (0, _classes.ImmutableMap)({})) => (0, _reduce.default)((accum, selector) => (0, _findWildcards2.default)(selector, accum), wildcards, selectors);

  var replaceWildcards = wildValues => createSelector((0, _map.default)((0, _replaceWildcards2.default)(wildValues), selectors), reducer);

  var select;

  if (containsWildcard()) {
    select = SELECT_DEFAULT;
  } else if (reducer) {
    reducer = (0, _weakMemoize.default)(reducer);
    select = (0, _weakMemoize.default)(state => {
      var results = (0, _map.default)(selector => (0, _select2.default)(selector, state), selectors);
      return reducer(...results);
    });
  } else {
    select = (0, _weakMemoize.default)(state => {
      var results = (0, _map.default)(selector => (0, _select2.default)(selector, state), selectors);

      if (results.length === 1) {
        return results[0];
      }

      return results;
    });
  }

  return {
    containsWildcard,
    findWildcards,
    reducer,
    replaceWildcards,
    select,
    selectors
  };
};

var _default = createSelector;
exports.default = _default;
//# sourceMappingURL=createSelector.js.map