"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _bluebird = _interopRequireDefault(require("bluebird"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Creates a promise with the resolve and reject methods exposed as properties
 * on the promise.
 *
 * @function
 * @since v0.1.0
 * @category lang
 * @returns {Promise} The promise with exposed methods
 * @example
 *
 * const promise = externalPromise()
 * // ... do something async then eventually resolve the promise
 * promise.resolve(someValue)
 */
var externalPromise = () => {
  var rejectPromise;
  var resolvePromise;
  var promise = new _bluebird.default((resolve, reject) => {
    rejectPromise = reject;
    resolvePromise = resolve;
  });
  promise.reject = rejectPromise;
  promise.resolve = resolvePromise;
  return promise;
};

var _default = externalPromise;
exports.default = _default;
//# sourceMappingURL=externalPromise.js.map