"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _assoc = _interopRequireDefault(require("./assoc"));

var _classes = require("./classes");

var _createPath = _interopRequireDefault(require("./createPath"));

var _equals = _interopRequireDefault(require("./equals"));

var _getProperty = _interopRequireDefault(require("./getProperty"));

var _isFunction = _interopRequireDefault(require("./isFunction"));

var _isSelector = _interopRequireDefault(require("./isSelector"));

var _isWildcard = _interopRequireDefault(require("./isWildcard"));

var _reduce = _interopRequireDefault(require("./reduce"));

var _slice = _interopRequireDefault(require("./slice"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var findWildcards = (selector, wildcards = (0, _classes.ImmutableMap)([])) => {
  if ((0, _isFunction.default)(selector)) {
    return wildcards;
  }

  if ((0, _isSelector.default)(selector)) {
    return selector.findWildcards(wildcards);
  }

  selector = (0, _createPath.default)(selector);
  return (0, _reduce.default)((accum, name, index) => {
    if ((0, _isWildcard.default)(name)) {
      var basePath = (0, _slice.default)(0, index, selector);
      var existing = (0, _getProperty.default)(name, accum);

      if (existing) {
        if (!(0, _equals.default)((0, _getProperty.default)('basePath', existing), basePath)) {
          throw new Error("wild cards with the same name must have the same basePath");
        }
      } else {
        return (0, _assoc.default)(name, (0, _classes.ImmutableMap)({
          basePath,
          name
        }), accum);
      }
    }

    return accum;
  }, wildcards, selector);
};

var _default = findWildcards;
exports.default = _default;
//# sourceMappingURL=findWildcards.js.map