"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defn = _interopRequireDefault(require("./defn"));

var _slice = _interopRequireDefault(require("./slice"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Returns all but the last element of the given list or string.
 *
 * @function
 * @since v0.0.5
 * @category lang
 * @sig [a] -> [a]
 * @param {*} list The list to select from
 * @returns {*} A new array or string of all but the last element in the list
 * @example
 *
 * init([1, 2, 3])  //=> [1, 2]
 * init([1, 2])     //=> [1]
 * init([1])        //=> []
 * init([]);         //=> []
 *
 * init('abc')  //=> 'ab'
 * init('ab')   //=> 'a'
 * init('a')    //=> ''
 * init('')     //=> ''
 */
var init = (0, _defn.default)('init', (0, _slice.default)(0, -1));
var _default = init;
exports.default = _default;
//# sourceMappingURL=init.js.map