"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defn = _interopRequireDefault(require("./defn"));

var _util = require("./util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Checks if `any` is plain function. A plain function is not an AsyncFunction and not a GeneratorFunction
 *
 * @function
 * @since v0.3.0
 * @category lang
 * @param {*} any The value to check.
 * @returns {boolean} Returns `true` if `any` is a plain function, else `false`.
 * @example
 *
 * isPlainFunction(() => {})
 * // => true
 *
 * isPlainFunction(function() {})
 * // => true
 *
 * isPlainFunction(async function() {})
 * // => false
 *
 * isPlainFunction(function* () {})
 * // => false
 */
var isPlainFunction = (0, _defn.default)('isPlainFunction', _util.anyIsPlainFunction);
var _default = isPlainFunction;
exports.default = _default;
//# sourceMappingURL=isPlainFunction.js.map