"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _curry = _interopRequireDefault(require("./curry"));

var _util = require("./util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Checks if `value` is classified as a `Symbol` primitive or object.
 *
 * @function
 * @since v0.1.0
 * @category lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
 * @example
 *
 * isSymbol(Symbol.iterator)
 * // => true
 *
 * isSymbol(Symbol('abc'))
 * // => true
 *
 * isSymbol(Symbol.for('abc'))
 * // => true
 *
 * isSymbol('abc')
 * // => false
 */
var isSymbol = (0, _curry.default)(_util.anyIsSymbol);
var _default = isSymbol;
exports.default = _default;
//# sourceMappingURL=isSymbol.js.map