"use strict";

require("core-js/modules/es.array.iterator");

require("core-js/modules/web.dom-collections.iterator");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _indexes = _interopRequireDefault(require("./indexes"));

var _isFunction = _interopRequireDefault(require("./isFunction"));

var _properties = _interopRequireDefault(require("./properties"));

var _satisfiesIndexed = _interopRequireDefault(require("./satisfiesIndexed"));

var _satisfiesPropertied = _interopRequireDefault(require("./satisfiesPropertied"));

var _util = require("./util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var keys = value => {
  if (value && (0, _isFunction.default)(value.keySeq)) {
    return value.keySeq().toList();
  }

  if (value && (0, _isFunction.default)(value.keys)) {
    return (0, _util.iteratorToArray)(value.keys());
  }

  if ((0, _satisfiesIndexed.default)(value)) {
    return (0, _indexes.default)(value);
  }

  if ((0, _satisfiesPropertied.default)(value)) {
    return (0, _properties.default)(value);
  }

  throw new Error("Cannot get keys of the given value ".concat(value));
};

var _default = keys;
exports.default = _default;
//# sourceMappingURL=keys.js.map