"use strict";

require("core-js/modules/es.promise");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _all = _interopRequireDefault(require("./all"));

var _externalPromise = _interopRequireDefault(require("./externalPromise"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var listPromise = (values = []) => {
  var promise = (0, _externalPromise.default)();
  var reject = promise.reject,
      resolve = promise.resolve;
  promise.promises = values;

  promise.push = function (value) {
    this.promises.push(value);
    return this;
  };

  promise.resolve = function () {
    if (this.promises.length === 0) {
      return resolve(this.promises);
    }

    return Promise.resolve((0, _all.default)(this.promises)).then(results => {
      resolve(results);
      return promise;
    }).catch(error => reject(error));
  };

  return promise;
};

var _default = listPromise;
exports.default = _default;
//# sourceMappingURL=listPromise.js.map