"use strict";

require("core-js/modules/es.array.iterator");

require("core-js/modules/web.dom-collections.iterator");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _curryN = _interopRequireDefault(require("./curryN"));

var _getProperty = _interopRequireDefault(require("./getProperty"));

var _isArray = _interopRequireDefault(require("./isArray"));

var _isString = _interopRequireDefault(require("./isString"));

var _maxWith = _interopRequireDefault(require("./maxWith"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var maxBy = (0, _curryN.default)(2, (transform, ...values) => {
  if ((0, _isString.default)(transform)) {
    transform = (0, _getProperty.default)(transform);
  }

  if (values.length === 1 && (0, _isArray.default)(values[0])) {
    values = values[0];
  }

  return (0, _maxWith.default)((valueA, valueB) => transform(valueB) > transform(valueA) ? valueB : valueA, ...values);
});
var _default = maxBy;
exports.default = _default;
//# sourceMappingURL=maxBy.js.map