"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _Op = _interopRequireDefault(require("./classes/Op"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Creates an op object that can be yielded by a generator and intercepted/executed by any generator middleware
 *
 * @function
 * @since v0.1.0
 * @category lang
 * @param {Function} fn The function to execute when the op is executed
 * @returns {Object} The op object
 */
var op = fn => new _Op.default(fn);

var _default = op;
exports.default = _default;
//# sourceMappingURL=op.js.map