"use strict";

require("core-js/modules/es.promise");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _invariant = _interopRequireDefault(require("./invariant"));

var _isFunction = _interopRequireDefault(require("./isFunction"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var promisfy = func => {
  (0, _invariant.default)((0, _isFunction.default)(func), 'func must be a Function');
  return function (...args) {
    return new Promise((resolve, reject) => {
      args.push((err, value) => {
        if (err) {
          return reject(err);
        }

        return resolve(value);
      });
      func.apply(this, args);
    });
  };
};

var _default = promisfy;
exports.default = _default;
//# sourceMappingURL=promisfy.js.map