"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _containsWildcard = _interopRequireDefault(require("./containsWildcard"));

var _createPath = _interopRequireDefault(require("./createPath"));

var _curry = _interopRequireDefault(require("./curry"));

var _isArray = _interopRequireDefault(require("./isArray"));

var _isFunction = _interopRequireDefault(require("./isFunction"));

var _isImmutableList = _interopRequireDefault(require("./isImmutableList"));

var _isNil = _interopRequireDefault(require("./isNil"));

var _isString = _interopRequireDefault(require("./isString"));

var _join = _interopRequireDefault(require("./join"));

var _map = _interopRequireDefault(require("./map"));

var _replaceWildcard = _interopRequireDefault(require("./replaceWildcard"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var replaceWildcards = (0, _curry.default)((wildValues, value) => {
  if ((0, _isNil.default)(value)) {
    throw new Error("replaceWildcards expects 'value' to be not nil");
  }

  if (!(0, _containsWildcard.default)(value)) {
    return value;
  }

  if ((0, _isFunction.default)(value.replaceWildcards)) {
    return value.replaceWildcards(wildValues);
  }

  if ((0, _isString.default)(value)) {
    return (0, _join.default)('.', (0, _map.default)((0, _replaceWildcard.default)(wildValues), (0, _createPath.default)(value)));
  }

  if ((0, _isArray.default)(value) || (0, _isImmutableList.default)(value)) {
    return (0, _map.default)((0, _replaceWildcard.default)(wildValues), value);
  }

  throw new Error("Cannot replace wildcards for value ".concat(value));
});
var _default = replaceWildcards;
exports.default = _default;
//# sourceMappingURL=replaceWildcards.js.map