"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _curry = _interopRequireDefault(require("./curry"));

var _util = require("./util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Resolves a value to a generator using the generator to yield values.
 *
 * @function
 * @since v0.0.16
 * @category lang
 * @param {Any} value The value to resolve with the generator
 * @returns {Generator}
 * @example
 *
 * const generator = resolveToGenerator('foo')
 * generator.next() //=> { value: 'foo', done: true }
 */
var resolveToGenerator = (0, _curry.default)(_util.anyResolveToGenerator);
var _default = resolveToGenerator;
exports.default = _default;
//# sourceMappingURL=resolveToGenerator.js.map