"use strict";

require("core-js/modules/es.array.iterator");

require("core-js/modules/web.dom-collections.iterator");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _curry = _interopRequireDefault(require("./curry"));

var _getPath = _interopRequireDefault(require("./getPath"));

var _isArray = _interopRequireDefault(require("./isArray"));

var _isFunction = _interopRequireDefault(require("./isFunction"));

var _isImmutableList = _interopRequireDefault(require("./isImmutableList"));

var _isNil = _interopRequireDefault(require("./isNil"));

var _isSelector = _interopRequireDefault(require("./isSelector"));

var _isString = _interopRequireDefault(require("./isString"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var select = (0, _curry.default)((selector, state, ...rest) => {
  if ((0, _isNil.default)(selector)) {
    return state;
  }

  if ((0, _isFunction.default)(selector)) {
    return selector(state, ...rest);
  }

  if ((0, _isSelector.default)(selector)) {
    return selector.select(state, ...rest);
  }

  if ((0, _isArray.default)(selector) || (0, _isImmutableList.default)(selector) || (0, _isString.default)(selector)) {
    return (0, _getPath.default)(selector, state);
  }

  throw new TypeError("unknown selector type ".concat(selector));
});
var _default = select;
exports.default = _default;
//# sourceMappingURL=select.js.map