"use strict";

require("core-js/modules/es.array.concat");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _assoc = _interopRequireDefault(require("./assoc"));

var _classes = require("./classes");

var _concat = _interopRequireDefault(require("./concat"));

var _containsWildcard = _interopRequireDefault(require("./containsWildcard"));

var _curry = _interopRequireDefault(require("./curry"));

var _findWildcards = _interopRequireDefault(require("./findWildcards"));

var _getPath = _interopRequireDefault(require("./getPath"));

var _getProperty = _interopRequireDefault(require("./getProperty"));

var _head = _interopRequireDefault(require("./head"));

var _isFunction = _interopRequireDefault(require("./isFunction"));

var _isNil = _interopRequireDefault(require("./isNil"));

var _isObject = _interopRequireDefault(require("./isObject"));

var _keys = _interopRequireDefault(require("./keys"));

var _map = _interopRequireDefault(require("./map"));

var _reduce = _interopRequireDefault(require("./reduce"));

var _replaceWildcards = _interopRequireDefault(require("./replaceWildcards"));

var _size = _interopRequireDefault(require("./size"));

var _sort = _interopRequireDefault(require("./sort"));

var _tail = _interopRequireDefault(require("./tail"));

var _toStringPath = _interopRequireDefault(require("./toStringPath"));

var _values = _interopRequireDefault(require("./values"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var sortWildcards = wildcards => (0, _sort.default)((itemA, itemB) => (0, _toStringPath.default)((0, _getProperty.default)('basePath', itemA)) > (0, _toStringPath.default)((0, _getProperty.default)('basePath', itemB)), (0, _values.default)(wildcards));

var reduceWildcard = (wildcards, wildValues, results, state) => {
  if ((0, _size.default)(wildcards) === 0) {
    return results;
  }

  var wildcard = (0, _head.default)(wildcards);
  var basePath = (0, _getProperty.default)('basePath', wildcard);
  var name = (0, _getProperty.default)('name', wildcard);

  if ((0, _containsWildcard.default)(basePath)) {
    try {
      basePath = (0, _replaceWildcards.default)(wildValues, basePath);
    } catch (error) {
      if (error.message.contains('wildValues missing')) {
        return results;
      }

      throw error;
    }
  }

  var value = (0, _getPath.default)(basePath, state);

  if ((0, _size.default)(wildcards) === 1) {
    if ((0, _isNil.default)(value)) {
      // if (!isEmpty(wildValues)) {
      //   return append(wildValues, results)
      // }
      return results;
    }

    if (!(0, _isObject.default)(value) || (0, _isFunction.default)(value)) {
      throw new Error("Wildcard path used on non object value - basePath: ".concat(basePath, " value: ").concat(value));
    }

    return (0, _concat.default)(results, (0, _map.default)(wildValue => (0, _assoc.default)(name, wildValue, wildValues), (0, _keys.default)(value)));
  }

  return (0, _reduce.default)((accum, wildValue) => reduceWildcard((0, _tail.default)(wildcards), (0, _assoc.default)(name, wildValue, wildValues), accum, state), results, (0, _keys.default)(value));
};

var selectWildcards = (0, _curry.default)((selector, state) => {
  var wildcards = sortWildcards((0, _findWildcards.default)(selector));
  var wildValues = (0, _classes.ImmutableMap)({});
  var results = (0, _classes.ImmutableList)([]);
  return reduceWildcard(wildcards, wildValues, results, state);
});
var _default = selectWildcards;
exports.default = _default;
//# sourceMappingURL=selectWildcards.js.map