"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _ramda = require("ramda");

var _isArrayLike = _interopRequireDefault(require("./isArrayLike"));

var _isImmutable = _interopRequireDefault(require("./isImmutable"));

var _isMap = _interopRequireDefault(require("./isMap"));

var _isObject = _interopRequireDefault(require("./isObject"));

var _isSet = _interopRequireDefault(require("./isSet"));

var _keys = _interopRequireDefault(require("./keys"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var size = value => {
  if ((0, _isImmutable.default)(value) || (0, _isMap.default)(value) || (0, _isSet.default)(value)) {
    return value.size;
  }

  if ((0, _isArrayLike.default)(value)) {
    return (0, _ramda.length)(value);
  }

  if ((0, _isObject.default)(value)) {
    return (0, _ramda.length)((0, _keys.default)(value));
  }

  return (0, _ramda.length)(value);
};

var _default = size;
exports.default = _default;
//# sourceMappingURL=size.js.map