"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _anyIsObjectLike = _interopRequireDefault(require("./anyIsObjectLike"));

var _anyToStringTag = _interopRequireDefault(require("./anyToStringTag"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Checks if `any` is likely an `arguments` object.
 *
 * @private
 * @function
 * @category lang.util
 * @since v0.1.0
 * @param {*} any The value to check.
 * @returns {boolean} Returns `true` if `any` is an `arguments` object, else `false`.
 * @example
 *
 * anyIsArguments(function() { return arguments }())
 * // => true
 *
 * anyIsArguments([1, 2, 3])
 * // => false
 */
var anyIsArguments = any => (0, _anyIsObjectLike.default)(any) && (0, _anyToStringTag.default)(any) == 'Arguments';

var _default = anyIsArguments;
exports.default = _default;
//# sourceMappingURL=anyIsArguments.js.map