"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _Array = _interopRequireDefault(require("../classes/Array"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Checks if `any` is classified as an `Array` object.
 *
 * @private
 * @function
 * @since v0.1.0
 * @category lang.util
 * @param {*} any The value to check.
 * @returns {boolean} Returns `true` if `any` is an array, else `false`.
 * @example
 *
 * anyIsArray([1, 2, 3])
 * //=> true
 *
 * anyIsArray(document.body.children)
 * //=> false
 *
 * anyIsArray('abc')
 * //=> false
 *
 * anyIsArray(noop)
 * //=> false
 */
var anyIsArray = _Array.default.isArray;
var _default = anyIsArray;
exports.default = _default;
//# sourceMappingURL=anyIsArray.js.map