"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _anyIsObjectLike = _interopRequireDefault(require("./anyIsObjectLike"));

var _anyToStringTag = _interopRequireDefault(require("./anyToStringTag"));

var _nodeTypes = _interopRequireDefault(require("./nodeTypes"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* Node.js helper references. */
var nodeIsArrayBuffer = _nodeTypes.default && _nodeTypes.default.anyIsArrayBuffer;
/**
 * Checks if `any` is classified as an `ArrayBuffer` object.
 *
 * @private
 * @function
 * @since v0.1.0
 * @category lang.util
 * @param {*} any The value to check.
 * @returns {boolean} Returns `true` if `any` is an array buffer, else `false`.
 * @example
 *
 * anyIsArrayBuffer(new ArrayBuffer(2))
 * // => true
 *
 * anyIsArrayBuffer(new Array(2))
 * // => false
 */

var anyIsArrayBuffer = nodeIsArrayBuffer ? nodeIsArrayBuffer : any => (0, _anyIsObjectLike.default)(any) && (0, _anyToStringTag.default)(any) == 'ArrayBuffer';
var _default = anyIsArrayBuffer;
exports.default = _default;
//# sourceMappingURL=anyIsArrayBuffer.js.map