"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _anyIsObjectLike = _interopRequireDefault(require("./anyIsObjectLike"));

var _anyToStringTag = _interopRequireDefault(require("./anyToStringTag"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Checks if `value` is classified as a boolean primitive or object.
 *
 * @private
 * @function
 * @since v0.1.0
 * @category lang.util
 * @param {*} any The value to check.
 * @returns {boolean} Returns `true` if `value` is a boolean, else `false`.
 * @example
 *
 * anyIsBoolean(false)
 * // => true
 *
 * anyIsBoolean(null)
 * // => false
 */
var anyIsBoolean = any => any === true || any === false || (0, _anyIsObjectLike.default)(any) && (0, _anyToStringTag.default)(any) == 'Boolean';

var _default = anyIsBoolean;
exports.default = _default;
//# sourceMappingURL=anyIsBoolean.js.map