"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _anyIsFunction = _interopRequireDefault(require("./anyIsFunction"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Checks if `any` is a buffer.
 *
 * @private
 * @function
 * @immutable
 * @pure
 * @since v0.1.0
 * @category lang.util
 * @param {*} any The value to check.
 * @returns {boolean} Returns `true` if `value` is a buffer, else `false`.
 * @example
 *
 * anyIsBuffer(new Buffer(2))
 * // => true
 *
 * anyIsBuffer(new Uint8Array(2))
 * // => false
 */
var anyIsBuffer = any => any != null && (0, _anyIsFunction.default)(any.fill) && (0, _anyIsFunction.default)(any.write);

var _default = anyIsBuffer;
exports.default = _default;
//# sourceMappingURL=anyIsBuffer.js.map