"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _anyIsObjectLike = _interopRequireDefault(require("./anyIsObjectLike"));

var _anyToStringTag = _interopRequireDefault(require("./anyToStringTag"));

var _nodeTypes = _interopRequireDefault(require("./nodeTypes"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* Node.js helper references. */
var nodeIsDate = _nodeTypes.default && _nodeTypes.default.anyIsDate;
/**
 * Checks if `any` is classified as a `Date` object.
 *
 * @private
 * @function
 * @since v0.1.0
 * @category lang.util
 * @param {*} any The value to check.
 * @returns {boolean} Returns `true` if `value` is a date object, else `false`.
 * @example
 *
 * anyIsDate(new Date)
 * //=> true
 *
 * anyIsDate('Mon April 23 2012')
 * //=> false
 */

var anyIsDate = nodeIsDate ? any => nodeIsDate(any) : any => (0, _anyIsObjectLike.default)(any) && (0, _anyToStringTag.default)(any) == 'Date';
var _default = anyIsDate;
exports.default = _default;
//# sourceMappingURL=anyIsDate.js.map