"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _anyIsFunction = _interopRequireDefault(require("./anyIsFunction"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Checks whether the given value is a generator.
 *
 * @private
 * @function
 * @since v0.1.0
 * @category lang.util
 * @param  {*} any The value to check.
 * @returns {boolean} Returns `true` if `value` is a generator, else `false`.
 * @example
 *
 * anyIsGenerator((function*() {})())  //=> true
 *
 * anyIsGenerator((function() {})())   //=> false
 *
 * anyIsGenerator({
 *   next: () => {},
 *   throw: () => {}
 * })  //=> true
 */
var anyIsGenerator = any => any && (0, _anyIsFunction.default)(any.next) && (0, _anyIsFunction.default)(any.throw);

var _default = anyIsGenerator;
exports.default = _default;
//# sourceMappingURL=anyIsGenerator.js.map