"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _immutable = _interopRequireDefault(require("immutable"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Returns `true` if `any` is an `ImmutableCollection`, or any of its subclasses.
 *
 * @private
 * @function
 * @since v0.1.0
 * @category lang.util
 * @param {*} any The value to check.
 * @returns {boolean} Returns `true` if `any` is an `ImmutableCollection`, or any of its subclasses.
 * @example
 *
 * anyIsImmutableCollection([])
 * //=> false
 *
 * anyIsImmutableCollection({})
 * //=> false
 *
 * anyIsImmutableCollection(ImmutableMap())
 * //=> true
 *
 * anyIsImmutableCollection(ImmutableList())
 * //=> true
 *
 * anyIsImmutableCollection(ImmutableStack())
 * //=> true
 */
var anyIsImmutableCollection = _immutable.default.isCollection;
var _default = anyIsImmutableCollection;
exports.default = _default;
//# sourceMappingURL=anyIsImmutableCollection.js.map