"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _immutable = _interopRequireDefault(require("immutable"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Returns `true` if `any` is an `ImmutableList`, or any of its subclasses.
 *
 * @private
 * @function
 * @since v0.1.0
 * @category lang.util
 * @param {*} any The value to check.
 * @returns {boolean} Returns `true` if `any` is an `ImmutableList`, or any of its subclasses.
 * @example
 *
 * anyIsImmutableList([])
 * //=> false
 *
 * anyIsImmutableList({})
 * //=> false
 *
 * anyIsImmutableList(ImmutableMap())
 * //=> false
 *
 * anyIsImmutableList(ImmutableList())
 * //=> true
 *
 * anyIsImmutableList(ImmutableStack())
 * //=> false
 */
var anyIsImmutableList = any => _immutable.default.isList(any);

var _default = anyIsImmutableList;
exports.default = _default;
//# sourceMappingURL=anyIsImmutableList.js.map