"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _immutable = _interopRequireDefault(require("immutable"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Returns `true` if `any` is an `ImmutableMap`, or any of its subclasses.
 *
 * @private
 * @function
 * @since v0.1.0
 * @category lang.util
 * @param {*} any The value to check.
 * @returns {boolean} Returns `true` if `any` is an `ImmutableMap`, or any of its subclasses.
 * @example
 *
 * anyIsImmutableMap([])
 * //=> false
 *
 * anyIsImmutableMap({})
 * //=> false
 *
 * anyIsImmutableMap(ImmutableMap())
 * //=> true
 *
 * anyIsImmutableMap(ImmutableList())
 * //=> false
 *
 * anyIsImmutableMap(ImmutableStack())
 * //=> false
 */
var anyIsImmutableMap = _immutable.default.isMap;
var _default = anyIsImmutableMap;
exports.default = _default;
//# sourceMappingURL=anyIsImmutableMap.js.map