"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _immutable = _interopRequireDefault(require("immutable"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Returns `true` if `any` is an `ImmutableOrderedMap`, or any of its subclasses.
 *
 * @private
 * @function
 * @since v0.1.0
 * @category lang.util
 * @param {*} any The value to check.
 * @returns {boolean} Returns `true` if `any` is an `ImmutableOrderedMap`, or any of its subclasses.
 * @example
 *
 * anyIsImmutableOrderedMap([])
 * //=> false
 *
 * anyIsImmutableOrderedMap({})
 * //=> false
 *
 * anyIsImmutableOrderedMap(new Map())
 * //=> false
 *
 * anyIsImmutableOrderedMap(ImmutableMap())
 * //=> false
 *
 * anyIsImmutableOrderedMap(ImmutableStack())
 * //=> false
 *
 * anyIsImmutableOrderedMap(ImmutableOrderedMap())
 * //=> true
 */
var anyIsImmutableOrderedMap = _immutable.default.isOrderedMap;
var _default = anyIsImmutableOrderedMap;
exports.default = _default;
//# sourceMappingURL=anyIsImmutableOrderedMap.js.map