"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _immutable = _interopRequireDefault(require("immutable"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Returns `true` if `any` is an `ImmutableOrderedSet`, or any of its subclasses.
 *
 * @private
 * @function
 * @since v0.1.0
 * @category lang.util
 * @param {*} any The value to check.
 * @returns {boolean} Returns `true` if `any` is an `ImmutableOrderedSet`, or any of its subclasses.
 * @example
 *
 * anyIsImmutableOrderedSet([])
 * //=> false
 *
 * anyIsImmutableOrderedSet({})
 * //=> false
 *
 * anyIsImmutableOrderedSet(new Set())
 * //=> false
 *
 * anyIsImmutableOrderedSet(ImmutableMap())
 * //=> false
 *
 * anyIsImmutableOrderedSet(ImmutableStack())
 * //=> false
 *
 * anyIsImmutableOrderedSet(ImmutableSet())
 * //=> false
 *
 * anyIsImmutableOrderedSet(ImmutableOrderedSet())
 * //=> true
 */
var anyIsImmutableOrderedSet = _immutable.default.isOrderedSet;
var _default = anyIsImmutableOrderedSet;
exports.default = _default;
//# sourceMappingURL=anyIsImmutableOrderedSet.js.map