"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _immutable = _interopRequireDefault(require("immutable"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Returns `true` if `any` is an `ImmutableSet`, or any of its subclasses.
 *
 * @private
 * @function
 * @since v0.1.0
 * @category lang.util
 * @param {*} any The value to check.
 * @returns {boolean} Returns `true` if `any` is an `ImmutableSet`, or any of its subclasses.
 * @example
 *
 * anyIsImmutableSet([])
 * //=> false
 *
 * anyIsImmutableSet({})
 * //=> false
 *
 * anyIsImmutableSet(ImmutableMap())
 * //=> false
 *
 * anyIsImmutableSet(ImmutableSet())
 * //=> true
 *
 * anyIsImmutableSet(ImmutableStack())
 * //=> false
 */
var anyIsImmutableSet = _immutable.default.isSet;
var _default = anyIsImmutableSet;
exports.default = _default;
//# sourceMappingURL=anyIsImmutableSet.js.map