"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _immutable = _interopRequireDefault(require("immutable"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Returns `true` if `any` is an `ImmutableStack`, or any of its subclasses.
 *
 * @private
 * @function
 * @since v0.1.0
 * @category lang.util
 * @param {*} any The value to check.
 * @returns {boolean} Returns `true` if `any` is an `ImmutableStack`, or any of its subclasses.
 * @example
 *
 * anyIsImmutableStack([])
 * //=> false
 *
 * anyIsImmutableStack({})
 * //=> false
 *
 * anyIsImmutableStack(ImmutableMap())
 * //=> false
 *
 * anyIsImmutableStack(ImmutableSet())
 * //=> false
 *
 * anyIsImmutableStack(ImmutableStack())
 * //=> true
 */
var anyIsImmutableStack = _immutable.default.isStack;
var _default = anyIsImmutableStack;
exports.default = _default;
//# sourceMappingURL=anyIsImmutableStack.js.map