"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _Symbol = require("../constants/Symbol");

/**
 * Checks if `any` implements the iterator symbol or is iterable
 *
 * @private
 * @function
 * @since v0.1.0
 * @category lang.util
 * @param {*} any The value to check.
 * @returns {boolean} Returns `true` if `any` is iterable, else `false`.
 * @example
 *
 * anyIsIterable('abc')
 * //=> true
 *
 * anyIsIterable(new Map())
 * //=> true
 *
 * anyIsIterable({})
 * //=> false
 *
 * anyIsIterable([])
 * //=> true
 */
var anyIsIterable = any => any != null && any[_Symbol.ITERATOR] != null;

var _default = anyIsIterable;
exports.default = _default;
//# sourceMappingURL=anyIsIterable.js.map