"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _anyIsObjectLike = _interopRequireDefault(require("./anyIsObjectLike"));

var _anyToStringTag = _interopRequireDefault(require("./anyToStringTag"));

var _nodeTypes = _interopRequireDefault(require("./nodeTypes"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* Node.js helper references. */
var nodeIsMap = _nodeTypes.default && _nodeTypes.default.anyIsMap;
/**
 * Checks if `value` is classified as a `Map` object.
 *
 * @private
 * @function
 * @since v0.1.0
 * @category lang.util
 * @param {*} any The value to check.
 * @returns {boolean} Returns `true` if `value` is a map, else `false`.
 * @example
 *
 * anyIsMap(new Map) // => true
 *
 * anyIsMap(new WeakMap) // => false
 */

var anyIsMap = nodeIsMap ? any => nodeIsMap(any) : any => (0, _anyIsObjectLike.default)(any) && (0, _anyToStringTag.default)(any) == 'Map';
var _default = anyIsMap;
exports.default = _default;
//# sourceMappingURL=anyIsMap.js.map