"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/**
 * Checks if `any` is `null` or `undefined`.
 *
 * @private
 * @function
 * @since v0.1.0
 * @category lang.util
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `any` is nullish, else `false`.
 * @example
 *
 * anyIsNil(null)
 * // => true
 *
 * anyIsNil(void 0)
 * // => true
 *
 * anyIsNil(NaN)
 * // => false
 */
var anyIsNil = any => any == null;

var _default = anyIsNil;
exports.default = _default;
//# sourceMappingURL=anyIsNil.js.map