"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _Op = _interopRequireDefault(require("../classes/Op"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Determines if `any` is an Op.
 *
 * @private
 * @function
 * @since v0.1.0
 * @category lang.util
 * @param {*} any The value to check
 * @returns {boolean}
 * @example
 *
 * anyIsOp(new Op(fn))
 * //=> true
 *
 * anyIsOp({
 *   ['@@redux-saga/IO']: 'op'
 * })
 * //=> true
 */
var anyIsOp = any => !!(any && (any instanceof _Op.default || any['@@redux-saga/IO']));

var _default = anyIsOp;
exports.default = _default;
//# sourceMappingURL=anyIsOp.js.map