"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _anyIsFunction = _interopRequireDefault(require("./anyIsFunction"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Checks whether the given value is a Promise.
 *
 * @private
 * @function
 * @since v0.1.0
 * @category lang.util
 * @param {*} any The value to check.
 * @returns {boolean} Returns `true` if `value` is a Promise, else `false`.
 * @example
 *
 * anyIsPromise(new Promise(() => {})) //=> true
 *
 * anyIsPromise({}) //=> false
 *
 * anyIsPromise({ then: () => {} }) //=> true
 */
var anyIsPromise = any => any != null && (0, _anyIsFunction.default)(any.then);

var _default = anyIsPromise;
exports.default = _default;
//# sourceMappingURL=anyIsPromise.js.map