"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _anyIsObjectLike = _interopRequireDefault(require("./anyIsObjectLike"));

var _anyToStringTag = _interopRequireDefault(require("./anyToStringTag"));

var _nodeTypes = _interopRequireDefault(require("./nodeTypes"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* Node.js helper references. */
var nodeIsRegExp = _nodeTypes.default && _nodeTypes.default.isRegExp;
/**
 * Checks if `any` is classified as a `RegExp` object.
 *
 * @private
 * @function
 * @since v0.1.0
 * @category lang.util
 * @param {*} any The value to check.
 * @returns {boolean} Returns `true` if `value` is a regexp, else `false`.
 * @example
 *
 * anyIsRegExp(/abc/)
 * //=> true
 *
 * anyIsRegExp('/abc/')
 * //=> false
 */

var anyIsRegExp = nodeIsRegExp ? nodeIsRegExp : any => (0, _anyIsObjectLike.default)(any) && (0, _anyToStringTag.default)(any) == 'RegExp';
var _default = anyIsRegExp;
exports.default = _default;
//# sourceMappingURL=anyIsRegExp.js.map