"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _immutable = _interopRequireDefault(require("immutable"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Returns `true` if `any` is a `Seq`.
 *
 * @private
 * @function
 * @since v0.1.0
 * @category lang.util
 * @param {*} any The value to check.
 * @returns {boolean} Returns `true` if `any` is a `Seq`.
 * @example
 *
 * anyIsSeq([])
 * //=> false
 *
 * anyIsSeq({})
 * //=> false
 *
 * anyIsSeq(ImmutableMap())
 * //=> false
 *
 * anyIsSeq(Seq())
 * //=> true
 */
var anyIsSeq = _immutable.default.isSeq;
var _default = anyIsSeq;
exports.default = _default;
//# sourceMappingURL=anyIsSeq.js.map