"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _anyIsObjectLike = _interopRequireDefault(require("./anyIsObjectLike"));

var _anyToStringTag = _interopRequireDefault(require("./anyToStringTag"));

var _nodeTypes = _interopRequireDefault(require("./nodeTypes"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* Node.js helper references. */
var nodeIsSet = _nodeTypes.default && _nodeTypes.default.anyIsSet;
/**
 * Checks if `any` is classified as a `Set` object.
 *
 * @private
 * @function
 * @since v0.1.0
 * @category lang.util
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a set, else `false`.
 * @example
 *
 * anyIsSet(new Set())
 * // => true
 *
 * anyIsSet(new WeakSet())
 * // => false
 */

var anyIsSet = nodeIsSet ? any => nodeIsSet(any) : any => (0, _anyIsObjectLike.default)(any) && (0, _anyToStringTag.default)(any) == 'Set';
var _default = anyIsSet;
exports.default = _default;
//# sourceMappingURL=anyIsSet.js.map