"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/**
 * Checks if `any` is `undefined`.
 *
 * @private
 * @function
 * @since v0.1.0
 * @category lang.util
 * @param {Any} any The value to check.
 * @returns {Boolean} Returns `true` if `any` is `undefined`, else `false`.
 * @example
 *
 * anyIsUndefined(void 0)
 * // => true
 *
 * anyIsUndefined(null)
 * // => false
 */
var anyIsUndefined = value => value === undefined;

var _default = anyIsUndefined;
exports.default = _default;
//# sourceMappingURL=anyIsUndefined.js.map