"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _anyIsObjectLike = _interopRequireDefault(require("./anyIsObjectLike"));

var _anyToStringTag = _interopRequireDefault(require("./anyToStringTag"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Checks if `any` is classified as a `WeakSet` object.
 *
 * @private
 * @function
 * @since v0.1.0
 * @category lang.util
 * @param {*} any The value to check.
 * @returns {boolean} Returns `true` if `any` is a weak set, else `false`.
 * @example
 *
 * anyIsWeakSet(new WeakSet())
 * // => true
 *
 * anyIsWeakSet(new Set())
 * // => false
 */
var anyIsWeakSet = any => (0, _anyIsObjectLike.default)(any) && (0, _anyToStringTag.default)(any) == 'WeakSet';

var _default = anyIsWeakSet;
exports.default = _default;
//# sourceMappingURL=anyIsWeakSet.js.map