"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _anyIsNil = _interopRequireDefault(require("./anyIsNil"));

var _anyIsObject = _interopRequireDefault(require("./anyIsObject"));

var _anyResolveWith = _interopRequireDefault(require("./anyResolveWith"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var anySetPathWith = (any, path, value, contagionFunc, getFunc, setFunc) => {
  if (path.size === 0) {
    return value;
  }

  var pathHead = path.get(0);

  if (path.size === 1) {
    return setFunc(any, pathHead, value);
  }

  return (0, _anyResolveWith.default)(getFunc(any, pathHead), headValue => {
    var pathTail = path.tail();

    if ((0, _anyIsNil.default)(headValue) || !(0, _anyIsObject.default)(headValue)) {
      headValue = contagionFunc(any, path.get(1));
    }

    return (0, _anyResolveWith.default)(anySetPathWith(headValue, pathTail, value, contagionFunc, getFunc, setFunc), setValue => {
      return setFunc(any, pathHead, setValue);
    });
  });
};

var _default = anySetPathWith;
exports.default = _default;
//# sourceMappingURL=anySetPathWith.js.map