"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _Path = _interopRequireDefault(require("../classes/Path"));

var _anyIsArray = _interopRequireDefault(require("./anyIsArray"));

var _anyIsImmutableList = _interopRequireDefault(require("./anyIsImmutableList"));

var _anyIsString = _interopRequireDefault(require("./anyIsString"));

var _stringToPath = _interopRequireDefault(require("./stringToPath"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Casts a value to an array path.
 *
 * @private
 * @function
 * @since v0.3.0
 * @category lang.util
 * @param {string} value The value to cast to an array path
 * @returns {Array<string>} The path
 * @example
 *
 * anyToPath('a.b.c')
 * //=> ['a', 'b', 'c']
 *
 */
var anyToPath = any => {
  if (!(0, _anyIsString.default)(any)) {
    if ((0, _anyIsArray.default)(any) || (0, _anyIsImmutableList.default)(any)) {
      return new _Path.default(any);
    }

    return new _Path.default([any]);
  }

  return (0, _stringToPath.default)(any);
};

var _default = anyToPath;
exports.default = _default;
//# sourceMappingURL=anyToPath.js.map