"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _Array = _interopRequireDefault(require("../classes/Array"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Clones the given `array`
 *
 * @private
 * @function
 * @since v0.1.0
 * @category lang.util
 * @param {Array} array The array to clone.
 * @returns {Array} Returns a clone of `array`.
 */
var arrayClone = array => {
  var index = -1;
  var length = array.length;
  var clone = (0, _Array.default)(length);

  while (++index < length) {
    clone[index] = array[index];
  }

  return clone;
};

var _default = arrayClone;
exports.default = _default;
//# sourceMappingURL=arrayClone.js.map