"use strict";

require("core-js/modules/es.array.iterator");

require("core-js/modules/web.dom-collections.iterator");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("regenerator-runtime/runtime");

var _anyIsGenerator = _interopRequireDefault(require("./anyIsGenerator"));

var _anyIsPromise = _interopRequireDefault(require("./anyIsPromise"));

var _indexEndOffset = _interopRequireDefault(require("./indexEndOffset"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var generatorReduce = /*#__PURE__*/regeneratorRuntime.mark(function generatorReduce(arrayLike, accum, iteratee, index) {
  var length;
  return regeneratorRuntime.wrap(function generatorReduce$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          if (!(0, _anyIsGenerator.default)(accum)) {
            _context.next = 3;
            break;
          }

          return _context.delegateYield(accum, "t0", 2);

        case 2:
          accum = _context.t0;

        case 3:
          length = arrayLike.length;

        case 4:
          if (!(index < length)) {
            _context.next = 18;
            break;
          }

          accum = iteratee(accum, arrayLike[index], index);

          if (!(0, _anyIsGenerator.default)(accum)) {
            _context.next = 11;
            break;
          }

          return _context.delegateYield(accum, "t1", 8);

        case 8:
          accum = _context.t1;
          _context.next = 15;
          break;

        case 11:
          if (!(0, _anyIsPromise.default)(accum)) {
            _context.next = 15;
            break;
          }

          _context.next = 14;
          return accum;

        case 14:
          accum = _context.sent;

        case 15:
          index += 1;
          _context.next = 4;
          break;

        case 18:
          return _context.abrupt("return", accum);

        case 19:
        case "end":
          return _context.stop();
      }
    }
  }, generatorReduce);
});

var baseArrayLikeReduce = (arrayLike, accum, iteratee, index = 0) => {
  var length = arrayLike.length;

  if ((0, _anyIsPromise.default)(accum)) {
    return accum.then(resolvedAccum => baseArrayLikeReduce(arrayLike, resolvedAccum, iteratee, index));
  } else if ((0, _anyIsGenerator.default)(accum)) {
    return generatorReduce(arrayLike, accum, iteratee, index);
  }

  while (index < length) {
    accum = iteratee(accum, arrayLike[index], index);

    if ((0, _anyIsPromise.default)(accum)) {
      return accum.then(resolvedAccum => baseArrayLikeReduce(arrayLike, resolvedAccum, iteratee, index + 1));
    } else if ((0, _anyIsGenerator.default)(accum)) {
      return generatorReduce(arrayLike, accum, iteratee, index + 1);
    }

    index += 1;
  }

  return accum;
};
/**
 * Reduces over an `ArrayLike` value
 *
 * @private
 * @function
 * @since v0.1.0
 * @category lang.util
 * @param {ArrayLike} arrayLike The array like value to iterate over.
 * @param {Function} iteratee The iterator function. Receives three values, the accumulator, the current value from the collection and the key or index.
 * @param {*} accum The accumulator value.
 * @param {number} index The index to start from
 * @returns {*} The final, accumulated value.
 */


var arrayLikeReduce = (arrayLike, accum, iteratee, index = 0) => {
  var length = arrayLike.length;
  index = (0, _indexEndOffset.default)(index, length);
  return baseArrayLikeReduce(arrayLike, accum, iteratee, index);
};

var _default = arrayLikeReduce;
exports.default = _default;
//# sourceMappingURL=arrayLikeReduce.js.map