"use strict";

require("core-js/modules/es.regexp.to-string");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _Function = _interopRequireDefault(require("../classes/Function"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var toString = _Function.default.prototype.toString;
/**
 * Returns a string representing the function.
 *
 * See [Function.prototype.toString()](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Function/toString) for more information
 *
 * @private
 * @function
 * @since v0.1.0
 * @category lang.util
 * @param {Function} func The function to convert to a string
 * @returns {string} A string representing the object.
 *
 * functionToString(function () {})
 * //=> 'function () {}'
 */

var functionToString = func => toString.call(func);

var _default = functionToString;
exports.default = _default;
//# sourceMappingURL=functionToString.js.map