"use strict";

require("core-js/modules/es.array.iterator");

require("core-js/modules/web.dom-collections.iterator");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("regenerator-runtime/runtime");

var _anyResolveToGeneratorWith = _interopRequireDefault(require("./anyResolveToGeneratorWith"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Resolves a Generator to a Generator yielding all values of the Generator to
 * the new one.
 *
 * @private
 * @function
 * @since v0.1.0
 * @category lang.util
 * @param {*} any The value to resolve with the generator
 * @returns {Generator}
 * @example
 *
 * const generator = anyResolveToGenerator('foo')
 * generator.next()
 * //=> { value: 'foo', done: true }
 */
var generatorResolveToGeneratorWith = /*#__PURE__*/regeneratorRuntime.mark(function generatorResolveToGeneratorWith(any, func) {
  var result;
  return regeneratorRuntime.wrap(function generatorResolveToGeneratorWith$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          return _context.delegateYield(any, "t0", 1);

        case 1:
          result = _context.t0;
          return _context.delegateYield((0, _anyResolveToGeneratorWith.default)(result, func), "t1", 3);

        case 3:
          return _context.abrupt("return", _context.t1);

        case 4:
        case "end":
          return _context.stop();
      }
    }
  }, generatorResolveToGeneratorWith);
});
var _default = generatorResolveToGeneratorWith;
exports.default = _default;
//# sourceMappingURL=generatorResolveToGeneratorWith.js.map