"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _anyIsResolved = _interopRequireDefault(require("./anyIsResolved"));

var _unresolvedResolveWith = _interopRequireDefault(require("./unresolvedResolveWith"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var resolveNext = (next, iterator, func, recur) => (0, _unresolvedResolveWith.default)(next, resolvedNext => {
  if (resolvedNext.done) {
    return resolvedNext.value;
  }

  return recur(iterator, func);
});

var iteratorIterate = (iterator, func) => {
  var _loop = function _loop() {
    var next = iterator.next();

    if (!(0, _anyIsResolved.default)(next)) {
      return {
        v: (0, _unresolvedResolveWith.default)(next, resolvedNext => {
          next = func(resolvedNext);

          if (!(0, _anyIsResolved.default)(next)) {
            return resolveNext(next, iterator, func, iteratorIterate);
          }

          if (next.done) {
            return next.value;
          }

          return iteratorIterate(iterator, func);
        })
      };
    }

    next = func(next);

    if (!(0, _anyIsResolved.default)(next)) {
      return {
        v: resolveNext(next, iterator, func, iteratorIterate)
      };
    }

    if (next.done) {
      return {
        v: next.value
      };
    }
  };

  while (true) {
    var _ret = _loop();

    if (typeof _ret === "object") return _ret.v;
  }
};

var _default = iteratorIterate;
exports.default = _default;
//# sourceMappingURL=iteratorIterate.js.map