"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/**
 * This method converts an `Iterator` into an `Array`
 *
 * @private
 * @function
 * @since v0.1.0
 * @category lang.util
 * @param {Iterator} iterator The Iterator to convert to an Array
 * @returns {Array} An `Array` of all the values from the `Iterator`
 * @example
 */
var iteratorToArray = iter => {
  var list = [];
  var next;

  while (!(next = iter.next()).done) {
    list.push(next.value);
  }

  return list;
};

var _default = iteratorToArray;
exports.default = _default;
//# sourceMappingURL=iteratorToArray.js.map