"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _mapClone = _interopRequireDefault(require("./mapClone"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Deletes a `Key` from a `Map`. Returns a new copy of the `Map` with the `Key`
 * removed.
 *
 * @private
 * @function
 * @immutable
 * @category lang.util
 * @since v0.1.0
 * @pure
 * @param {Map} map
 * @param {Key} key
 * @returns {Map}
 */
var mapDeleteKey = (map, key) => {
  if (!map.has(key)) {
    return map;
  }

  var clone = (0, _mapClone.default)(map);
  clone.delete(key);
  return clone;
};

var _default = mapDeleteKey;
exports.default = _default;
//# sourceMappingURL=mapDeleteKey.js.map