"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _anyIdenticalWithAny = _interopRequireDefault(require("./anyIdenticalWithAny"));

var _mapClone = _interopRequireDefault(require("./mapClone"));

var _mapGetKey = _interopRequireDefault(require("./mapGetKey"));

var _mapHasKey = _interopRequireDefault(require("./mapHasKey"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Deletes a `Key` from a `Map`. Returns a new copy of the `Map` with the `Key`
 * removed.
 *
 * @private
 * @function
 * @immutable
 * @pure
 * @category lang.util
 * @since v0.1.0
 * @param {Map} map
 * @param {Key} key
 * @param {Any} value
 * @returns {Map}
 */
var mapSetKey = (map, key, value) => {
  if ((0, _mapHasKey.default)(map, key) && (0, _anyIdenticalWithAny.default)((0, _mapGetKey.default)(map, key), value)) {
    return map;
  }

  var clone = (0, _mapClone.default)(map);
  clone.set(key, value);
  return clone;
};

var _default = mapSetKey;
exports.default = _default;
//# sourceMappingURL=mapSetKey.js.map