"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectAssign = _interopRequireDefault(require("./objectAssign"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * This method is used to copy the values of all enumerable own properties from
 * one object to a new object.
 *
 * @private
 * @function
 * @since v0.1.0
 * @category lang.util
 * @param {Object} object The object to copy.
 * @returns {Object} The new copy of the object.
 * @example
 *
 * const object = {
 *   a: 1,
 *   b: 2,
 *   c: 3
 * }
 *
 * const objectCopy = objectClone(object)
 * //=> {
 *   a: 1,
 *   b: 2,
 *   c: 3
 * }
 *
 * objectCopy === object
 * //=> false
 */
var objectClone = object => (0, _objectAssign.default)({}, object);

var _default = objectClone;
exports.default = _default;
//# sourceMappingURL=objectClone.js.map