"use strict";

require("core-js/modules/es.array.iterator");

require("core-js/modules/web.dom-collections.iterator");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("regenerator-runtime/runtime");

var _anyIsFunction = _interopRequireDefault(require("./anyIsFunction"));

var _anyIsGenerator = _interopRequireDefault(require("./anyIsGenerator"));

var _anyResolveToGenerator = _interopRequireDefault(require("./anyResolveToGenerator"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Resolves an unresolved value to a generator using the generator to yield values.
 *
 * @private
 * @function
 * @since v0.1.0
 * @category lang.util
 * @param {*} any The value to resolve with the generator
 * @returns {Generator}
 * @example
 *
 * const generator = unresolvedResolveToGenerator('foo')
 * generator.next()
 * //=> { value: 'foo', done: true }
 */
var unresolvedResolveToGenerator = /*#__PURE__*/regeneratorRuntime.mark(function unresolvedResolveToGenerator(unresolved) {
  var result;
  return regeneratorRuntime.wrap(function unresolvedResolveToGenerator$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          if (!(0, _anyIsGenerator.default)(unresolved)) {
            _context.next = 5;
            break;
          }

          return _context.delegateYield(unresolved, "t0", 2);

        case 2:
          result = _context.t0;
          _context.next = 12;
          break;

        case 5:
          if (!(0, _anyIsFunction.default)(unresolved.resolve)) {
            _context.next = 9;
            break;
          }

          result = unresolved.resolve();
          _context.next = 12;
          break;

        case 9:
          _context.next = 11;
          return unresolved;

        case 11:
          result = _context.sent;

        case 12:
          return _context.delegateYield((0, _anyResolveToGenerator.default)(result), "t1", 13);

        case 13:
          return _context.abrupt("return", _context.t1);

        case 14:
        case "end":
          return _context.stop();
      }
    }
  }, unresolvedResolveToGenerator);
});
var _default = unresolvedResolveToGenerator;
exports.default = _default;
//# sourceMappingURL=unresolvedResolveToGenerator.js.map