"use strict";

require("core-js/modules/es.array.iterator");

require("core-js/modules/es.set");

require("core-js/modules/web.dom-collections.iterator");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _curry = _interopRequireDefault(require("./curry"));

var _isObjectLike = _interopRequireDefault(require("./isObjectLike"));

var _map = _interopRequireDefault(require("./map"));

var _walk = _interopRequireDefault(require("./walk"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var mapWalkee = () => {
  var visited = new Set();
  return (iteratee, value, recur) => {
    if ((0, _isObjectLike.default)(value)) {
      value = (0, _map.default)(iteratee, value);

      if (!visited.has(value)) {
        return (0, _map.default)(child => recur(iteratee, child), value);
      }
    }

    return value;
  };
};

var walkMap = (0, _curry.default)((iteratee, collection) => (0, _walk.default)(mapWalkee(), iteratee, collection));
var _default = walkMap;
exports.default = _default;
//# sourceMappingURL=walkMap.js.map