"use strict";

require("core-js/modules/es.array.iterator");

require("core-js/modules/es.weak-map");

require("core-js/modules/web.dom-collections.iterator");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _curryN = _interopRequireDefault(require("./curryN"));

var _util = require("./util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var weakMemoizeWith = (0, _curryN.default)(2, (mFn, fn) => {
  var cache = new WeakMap();
  return (0, _util.functionDefineLength)((...args) => {
    var key = mFn(...args);

    if (!cache.has(key)) {
      var result = fn(...args);
      cache.set(key, result);
      return result;
    }

    return cache.get(key);
  }, fn.length);
});
var _default = weakMemoizeWith;
exports.default = _default;
//# sourceMappingURL=weakMemoizeWith.js.map