"use strict";

require("core-js/modules/es.array.filter");

require("core-js/modules/es.string.split");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _constants = require("./constants");

var _pathResolve = _interopRequireDefault(require("./pathResolve"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * return true if `dest` is a subdir of `path`, otherwise false.
 * NOTE: It only checks the path strings.
 *
 * @function
 * @since v0.5.0
 * @category path
 * @param {String} path The path to check
 * @param {String} dest The destination path to compare against
 * @returns {Boolean} returns true if `dest` is a subdir of `path`
 */
var isPathSubdir = (path, dest) => {
  var pathArr = (0, _pathResolve.default)(path).split(_constants.Path.SEPARATOR).filter(i => i);
  var destArr = (0, _pathResolve.default)(dest).split(_constants.Path.SEPARATOR).filter(i => i);
  return pathArr.reduce((acc, cur, i) => acc && destArr[i] === cur, true);
};

var _default = isPathSubdir;
exports.default = _default;
//# sourceMappingURL=isPathSubdir.js.map