"use strict";

require("core-js/modules/es.array.iterator");

require("core-js/modules/web.dom-collections.iterator");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lang = require("../lang");

var _formatAuth = _interopRequireDefault(require("./formatAuth"));

var _formatHash = _interopRequireDefault(require("./formatHash"));

var _formatHost = _interopRequireDefault(require("./formatHost"));

var _formatHostname = _interopRequireDefault(require("./formatHostname"));

var _formatHref = _interopRequireDefault(require("./formatHref"));

var _formatOrigin = _interopRequireDefault(require("./formatOrigin"));

var _formatPassword = _interopRequireDefault(require("./formatPassword"));

var _formatPathname = _interopRequireDefault(require("./formatPathname"));

var _formatPort = _interopRequireDefault(require("./formatPort"));

var _formatProtocol = _interopRequireDefault(require("./formatProtocol"));

var _formatQuery = _interopRequireDefault(require("./formatQuery"));

var _formatSearch = _interopRequireDefault(require("./formatSearch"));

var _formatSlashes = _interopRequireDefault(require("./formatSlashes"));

var _formatUsername = _interopRequireDefault(require("./formatUsername"));

var _parseURL = _interopRequireDefault(require("./parseURL"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var formatLocation = location => {
  var result = {
    auth: (0, _formatAuth.default)(location),
    hash: (0, _formatHash.default)(location),
    host: (0, _formatHost.default)(location),
    hostname: (0, _formatHostname.default)(location),
    href: (0, _formatHref.default)(location),
    origin: (0, _formatOrigin.default)(location),
    password: (0, _formatPassword.default)(location),
    pathname: (0, _formatPathname.default)(location),
    port: (0, _formatPort.default)(location),
    protocol: (0, _formatProtocol.default)(location),
    query: (0, _formatQuery.default)(location),
    search: (0, _formatSearch.default)(location),
    slashes: (0, _formatSlashes.default)(location),
    username: (0, _formatUsername.default)(location)
  };

  if (location.state) {
    return (0, _lang.assocProperty)('state', location.state, result);
  }

  return result;
};

var buildLocation = value => {
  if ((0, _lang.isString)(value)) {
    return buildLocation((0, _parseURL.default)(value));
  } else if ((0, _lang.isFunction)(value)) {
    return (...args) => buildLocation(value(...args));
  } else if ((0, _lang.isObject)(value)) {
    return formatLocation(value);
  }

  throw new TypeError("buildLocation expected 'value' parameter to be either a String, Function or Object. Instead received ".concat(value));
};

var _default = buildLocation;
exports.default = _default;
//# sourceMappingURL=buildLocation.js.map