"use strict";

require("core-js/modules/es.string.search");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _formatAuth = _interopRequireDefault(require("./formatAuth"));

var _formatHash = _interopRequireDefault(require("./formatHash"));

var _formatPathname = _interopRequireDefault(require("./formatPathname"));

var _formatProtocol = _interopRequireDefault(require("./formatProtocol"));

var _formatSearch = _interopRequireDefault(require("./formatSearch"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var formatHref = location => {
  var hash = location.hash,
      host = location.host,
      hostname = location.hostname,
      port = location.port,
      protocol = location.protocol,
      query = location.query,
      search = location.search,
      slashes = location.slashes,
      username = location.username;
  var href = '';

  if (protocol) {
    var formattedProtocol = (0, _formatProtocol.default)(location);
    href += formattedProtocol;

    if (slashes || formattedProtocol === 'http:' || formattedProtocol === 'https:' || formattedProtocol === 'ftp:' || formattedProtocol === 'ftps:' || formattedProtocol === 'gopher:' || formattedProtocol === 'file:') {
      href += '//';
    }
  }

  if (username && (host || hostname)) {
    href += "".concat((0, _formatAuth.default)(location), "@");
  }

  if (host) {
    href += host;
  } else if (hostname) {
    href += hostname;
  }

  if (port) {
    href += ":".concat(port);
  }

  var formattedPathname = (0, _formatPathname.default)(location);

  if (formattedPathname) {
    href += formattedPathname;
  }

  if (search || query) {
    href += (0, _formatSearch.default)(location);
  }

  if (hash) {
    href += (0, _formatHash.default)(location);
  }

  return href;
};

var _default = formatHref;
exports.default = _default;
//# sourceMappingURL=formatHref.js.map