"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _formatProtocol = _interopRequireDefault(require("./formatProtocol"));

var _formatSlashes = _interopRequireDefault(require("./formatSlashes"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var formatOrigin = location => {
  var host = location.host,
      hostname = location.hostname,
      port = location.port,
      protocol = location.protocol;
  var origin = '';

  if (protocol) {
    origin += (0, _formatProtocol.default)(location);

    if ((0, _formatSlashes.default)(location)) {
      origin += '//';
    }
  }

  if (host) {
    origin += host;
  } else if (hostname) {
    origin += hostname;
  }

  if (port) {
    origin += ":".concat(port);
  }

  return origin;
};

var _default = formatOrigin;
exports.default = _default;
//# sourceMappingURL=formatOrigin.js.map