"use strict";

require("core-js/modules/es.array.concat");

require("core-js/modules/es.string.search");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lang = require("../lang");

var formatSearch = ({
  query,
  search
}) => {
  query = query ? (0, _lang.cleanse)(query) : null;

  if ((0, _lang.isString)(search) && !(0, _lang.isEmpty)(search)) {
    return search;
  }

  if (query && !(0, _lang.isEmpty)(query)) {
    return '?' + (0, _lang.join)('&', (0, _lang.map)(searchKey => {
      var searchParam = (0, _lang.getProperty)(searchKey, query);

      if ((0, _lang.isObject)(searchParam)) {
        searchParam = JSON.stringify(searchParam);
      }

      return "".concat(searchKey, "=").concat(encodeURIComponent(searchParam));
    }, (0, _lang.keys)(query)));
  }

  return '';
};

var _default = formatSearch;
exports.default = _default;
//# sourceMappingURL=formatSearch.js.map