"use strict";

require("core-js/modules/es.string.search");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _url = require("url");

var _lang = require("../lang");

var _parseSearch = _interopRequireDefault(require("./parseSearch"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var parseURL = url => {
  (0, _lang.invariant)((0, _lang.isString)(url), 'URL must be a String');
  var location;

  try {
    location = new _url.URL(url);
  } catch (error) {
    location = (0, _url.parse)(url);
  }

  if (location.search) {
    location.query = (0, _parseSearch.default)(location.search);
  }

  return location;
};

var _default = parseURL;
exports.default = _default;
//# sourceMappingURL=parseURL.js.map