"use strict";

require("core-js/modules/es.promise");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("regenerator-runtime/runtime");

var _archiver = _interopRequireDefault(require("archiver"));

var _fs = require("../fs");

var _lang = require("../lang");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

/**
 * Zips up a target directory and outputs it to the given file path.
 *
 * @function
 * @since v0.6.0
 * @category zip
 * @param {*} directory
 * @param {*} outputFilePath
 */
var zipDirectoryToFilePath = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(directory, outputFilePath, {
    include = ['*']
  } = {}) {
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            return _context.abrupt("return", new Promise((resolve, reject) => {
              // create a file to stream archive data to.
              var output = (0, _fs.createWriteStream)(outputFilePath);
              var archive = (0, _archiver.default)('zip', {
                zlib: {
                  level: 9
                } // Sets the compression level.

              }); // listen for all archive data to be written
              // 'close' event is fired only when a file descriptor is involved

              output.on('close', resolve); // good practice to catch warnings (ie stat failures and other non-blocking errors)

              archive.on('warning', error => {
                // eslint-disable-next-line no-console
                console.warn(error);
              }); // good practice to catch this error explicitly

              archive.on('error', reject);
              archive.pipe(output);
              (0, _lang.forEach)(glob => archive.glob(glob, {
                cwd: directory
              }), include);
              archive.directory(directory, false); // finalize the archive (ie we are done appending files but streams have to finish yet)
              // 'close', 'end' or 'finish' may be fired right after calling this method so register to them beforehand

              archive.finalize();
            }));

          case 1:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function zipDirectoryToFilePath(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var _default = zipDirectoryToFilePath;
exports.default = _default;
//# sourceMappingURL=zipDirectoryToFilePath.js.map