import Number from '../classes/Number'

/**
 * This constant represents the maximum safe integer in JavaScript (2^53 - 1 or 9007199254740991).
 *
 * See [Number.MAX_SAFE_INTEGER](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Number/MAX_SAFE_INTEGER) for more information.
 *
 * @private
 * @type {number}
 * @since v0.1.0
 * @category lang.constants
 */
export const MAX_SAFE = Number.MAX_SAFE_INTEGER
